(*
 *  beware ircd, Internet Relay Chat server, bircservunit.pas
 *  Copyright (C) 2002 Bas Steendijk
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)

unit bircservunit;

{
check akick code with umode=0 and channel doesnt exist

- operonly or akick: place ban for user (operonly infinite loop problem)
}

interface

{$include bircserv.inc}

{
buttonconnect, buttondie
timer1: second handler
timer2: 20 secs handler (nickserv nag)
timerretry: 4 secs (reconnect)


}

uses
  {$ifdef win32}wsocket,wcore,{$else}lcore,lsocket,{$endif}
  {$ifndef nowinnt}bwinnt,{$endif}
  btime,bsearchtree,SysUtils, Classes,
  rndpass;

const
  versionstr='1.2.1'
  {$ifdef win32}+'.win32'{$endif}
  {$ifdef linux}+'.linux'{$endif}
  {$ifdef fpc}+'.fpc'{$endif}
  ;
  chanid='AAA';
  nickid='AAB';
  memoid='AAC';
  operid='AAD';
  configfile='bircserv.cfg';
  configfile2='bircserv.ini';
  nickservfile='nickserv.db';
  chanservfile='chanserv.db';
  maxuser2=30000;
  maxchannel2=10000;
  maxnaccess=9;
  maxmemo=30;
  maxslave=4;
  maxignore=15;
  maxchanuser=19;
  maxuserchan=1023;
  mparams=100;
  maxcaccess=199;
  maxsop=100;
  maxglist=1023;
  maxseen=1023;
  maxjupe=63;
  maxban=119;
  maxlevel=4;
  maxserver=127;

  logconnect=$1;
  logdisconnect=$2;
  logclient=$4;
  logquit=$8;
  logrecvkill=$10;
  logserver=$20;
  logsquit=$40;
  logrecvwallops=$80;
  logjoin=$100;
  logkick=$200;
  logaddgline=$400;
  logremovegline=$800;
  logadmin=$1000;
  lograw=$2000;
  loginvalid=$4000;
  maxscanreason=9;

{$ifndef win32}
const pidfile='bircserv.pid';
{$endif}

const
  numcmds=59;

cmds:array[0..numcmds] of string=(
'PRIVMSG','NICK','NOTICE','JOIN','MODE',
'QUIT','PART','TOPIC','INVITE','KICK',
'WALLOPS','PING','PONG','ERROR','KILL',
'USER','AWAY','ISON','SERVER','SQUIT',
'WHOIS','WHO','LIST','NAMES','USERHOST',
'PASS','SILENCE','LUSERS','TIME','OPER',
'CONNECT','VERSION','STATS','LINKS','ADMIN',
'NICKSERV','CHANSERV','MEMOSERV','NS','CS',
'MS','HELP','INFO','MOTD','SETTIME',
'REHASH','MAP','RESTART','DIE','GLINE',
'SETHOST','SVSNICK','WHOWAS','TRACE','OPTIONS',
'USERIP','BURST','END_OF_BURST','EOB_ACK','CREATE');

p10cmds:array[0..numcmds] of string=(
{'PRIVMSG','NICK','NOTICE','JOIN','MODE',}
'P','N','O','J','M',
{'QUIT','PART','TOPIC','INVITE','KICK',}
'Q','L','T','I','K',
{'WALLOPS','PING','PONG','ERROR','KILL',}
'WA','G','Z','Y','D',
{'USER','AWAY','ISON','SERVER','SQUIT',}
'USER','A','ISON','S','SQ',
{'WHOIS','WHO','LIST','NAMES','USERHOST',}
'W','H','LIST','E','USERHOST',
{'PASS','SILENCE','LUSERS','TIME','OPER',}
'PA','U','LU','TI','OPER',
{'CONNECT','VERSION','STATS','LINKS','ADMIN',}
'CO','V','R','LI','AD',
{'NICKSERV','CHANSERV','MEMOSERV','NS','CS',}
'NS','CS','MS','NS','CS',
{'MS','HELP','INFO','MOTD','SETTIME',}
'MS','HELP','F','MO','SE',
{'REHASH','MAP','RESTART','DIE','GLINE';}
'REHASH','MAP','RESTART','DIE','GL',
{'SETHOST','SVSNICK','WHOWAS','TRACE','OPTIONS',}
'SETHOST','SVSNICK','X','TR','OPTIONS',
{'USERIP','BURST','END_OF_BURST','EOB_ACK','CREATE');}
'USERIP','B','EB','EA','C');

cmdprivmsg=0;cmdnick=1;cmdnotice=2;cmdjoin=3;cmdmode=4;
cmdquit=5;cmdpart=6;cmdtopic=7;cmdinvite=8;cmdkick=9;
cmdwallops=10;cmdping=11;cmdpong=12;cmderror=13;cmdkill=14;
cmduser=15;cmdaway=16;cmdison=17;cmdserver=18;cmdsquit=19;
cmdwhois=20;cmdwho=21;cmdlist=22;cmdnames=23;cmduserhost=24;
cmdpass=25;cmdsilence=26;cmdlusers=27;cmdtime=28;cmdoper=29;
cmdconnect=30;cmdversion=31;cmdstats=32;cmdlinks=33;cmdadmin=34;
cmdnickserv=35;cmdchanserv=36;cmdmemoserv=37;cmdns=38;cmdcs=39;
cmdms=40;cmdhelp=41;cmdinfo=42;cmdmotd=43;cmdsettime=44;
cmdrehash=45;cmdmap=46;cmdrestart=47;cmddie=48;cmdgline=49;
cmdsethost=50;cmdsvsnick=51;cmdwhowas=52;cmdtrace=53;cmdoptions=54;
cmduserip=55;cmdburst=56;cmdendofburst=57;cmdeoback=58;cmdcreate=59;

privmsgconst='P';
noticeconst='O';

type
  tivar=array[0..0] of integer;
  pivar=^tivar;
  twords=array[0..mparams] of string;
  Tuser=class
    nick,unick,userid,host,gcos:string;
    nsnum:integer;
    nagstatus:integer; {-1=doe niets   0=moet nog starten   1=voor 60  2=tussen 60 en 40   3=40-20  4=20-0}
    identified,maskmatch:boolean;
    floodtime:integer;
    floodtriggered:boolean;
    s,w,i,x,g,d,o,r,sop,k:boolean;
    channel,channel2:array[0..maxchanuser] of integer;
    servernum,ts:integer;
    clonechecked:boolean;
    id:integer;
    idstr:string;
    slotnum:integer;
    binip:integer;
    ip:string;
  end;
  Tuserarray=array[0..maxuser2] of tuser;
  Tnickserv=class
    lastts:integer;
    nick,unick:string;
    gcos:string;
    lastmask:string;
    pass,email,url:string;
    regdate,lastdate:integer;
    num:integer;
    mask:array[0..maxnaccess] of string;
    ignore:array[0..maxignore] of string;
    privmsg,priv,oper:boolean;
    memo:array[0..maxmemo] of record
      sender:string;
      date:longint;
      s:string
    end
  end;
  tnsarray=array[0..maxuser2] of tnickserv;

  Tchannel=class
    name,uname:string;
    csnum:integer;
    c,i,m,n,p,t,s,x:boolean;
    l:integer;
    k,topic:string;
    ban:array[0..maxban] of string;
    user:array[0..maxuserchan] of integer;
    userflag:array[0..maxuserchan] of byte;
    size:integer;
    modeq:array[0..3] of string;
    needmode:boolean;
    ts:integer;
  end;
  tchannelarray=array[0..maxchannel2] of tchannel;
  Tchanserv=class
    name,uname:string;
    password:string;
    num:integer;
    founder,url,welcome:string;
    topic:string;
    aop:array[0..3,0..maxsop] of string;
    regdate,lastdate:integer;
    founderjoined:boolean;
    priv:boolean;       {not in lists}
    strictop:boolean;   {only op-level users may be opped}
    operop,operonly:boolean;     {any ircop is auto opped}
    mlockyes:string;
    mlockno:string;
    ts:integer;

    {c,i,m,n,p,t,s,x:boolean;
    l:integer;
    k:string;
    ban:array[0..maxban] of string;}
  end;
  tcsarray=array[0..maxchannel2] of tchanserv;
  tserver=class
    used:boolean;
    name,uname:string;
    p10id:integer;
    p10max:integer;
    p10slots:pivar;
    parentserver:integer;
  end;
  cprivsrec=record
    registered:boolean;
    level:integer;
    founder:boolean;
    strictop:boolean;
    avoice:boolean;
    aop:boolean; {user is op-level access}
  end;

  TForm1 = class(tcomponent)
    Timer1: TlTimer;
    Timer2: TlTimer;
    Timerretry: TlTimer;
    procedure ButtonconnectClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);

    procedure killchannel(b:integer);
    procedure send(s:string);
    procedure sendflush;
    procedure mesend(s:string);
    procedure nicksend(s:string);
    procedure chansend(s:string);
    procedure memosend(s:string);
    procedure opersend(s:string);
    procedure checkmail(num:integer);
    procedure flushallchanmode;
    procedure flushchanmode(channum:integer);
    procedure setchanmode(channum:integer;st:boolean;c:char;param:string);
    procedure chanaccess(channum,usernum:integer;var cprivs:cprivsrec);
    function nickaccess(usernum,nsnum:integer;password:string):integer;
    procedure bottalk(botnum,num:integer;s:string;nickatserver:boolean);
    procedure checksop(num:integer);
    procedure parsemodelock(s:string;csnum:integer);
    procedure parsemodechan(sendernum:integer;var params,params2:twords);
    procedure parsemodeuser(usernum:integer;s:string);
    procedure addgline(s1:string;date:integer;sender,s2:string);
    procedure sendgline(s1:string;date:integer;reason:string);
    procedure parsecommand(s:string);
    procedure receive(sender:tobject; error:word);
    procedure sendreset;
    procedure sendresetgline;
    procedure sendresetchan;
    procedure spawnservices;
    procedure connected(sender:tobject; error:word);
    procedure closed(sender:tobject; error:word);
    procedure nickchanged(num:integer);
    procedure newuser(num:integer);
    function adduser:integer;
    procedure removeuser(num:integer);
    procedure setnick(num:integer;s:string);
    function getnick(s:string):integer;
    function getp10id(s:string):int;
    procedure setns(num:integer;s:string);
    function getns(s:string):integer;
    procedure nicklist(sendtalk,match:string;max,num:integer);
    procedure chanlist(sendtalk,match:string;max,num:integer);
    function addchannel:integer;
    procedure removeuserchannel(channum,usernum:integer);
    procedure removechannel(num:integer);
    procedure setchanname(num:integer;s:string);
    function getchanname(s:string):integer;
    procedure setcs(num:integer;s:string);
    function getcs(s:string):integer;
    function onignore(num1,num2:integer):boolean;
    procedure identify(num,nsnum:integer);
    procedure startnag(num:integer);
    procedure sendmotd(sender:string);
    procedure addseen(num:integer);
    procedure init;
    procedure clearserver;
    procedure clearns;
    procedure clearcs;

    procedure loadconf;
    procedure loadnickserv;
    procedure savenickserv;
    procedure loadchanserv;
    procedure savechanserv;
    procedure loadoperserv;
    procedure saveoperserv;
    procedure loaddb;
    procedure savedb;

    procedure ButtondieClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);

    procedure FormClose;
    procedure Timer2Timer(Sender: TObject);
    procedure TimerretryTimer(Sender: TObject);
    procedure logwrite(i:integer;s:string);
    procedure sendoperchannel(num:integer;s:string);
    procedure destroyserver(b:integer);
  public
    {p10}
    logging:boolean;
    p10reverseserver:array[0..4095] of integer;
    p10idint:integer;
    p10id:string;
    usekill,usesettime:boolean;

    servername2:string;
    status:integer;
    sock:twsocket;
    {user db}
    user:^tuserarray;
    useravail:array[0..maxuser2] of boolean;
    nickhash:thashtable;
    maxuser:integer;
    {nickserv db}
    nickserv:^tnsarray;
    nsavail:array[0..maxuser2] of boolean;
    nshash:thashtable;
    maxns:integer;
    {channel db}
    channel:^tchannelarray;
    channelavail:array[0..maxchannel2] of boolean;
    channelhash:thashtable;
    maxchannel:integer;
    {chanserv db}
    chanserv:^tcsarray;
    csavail:array[0..maxchannel2] of boolean;
    cshash:thashtable;
    maxcs:integer;
    {other options}
    nicknick,channick,memonick,opernick:string;
    nickgcos,changcos,memogcos,opergcos:string;
    connectport,connectaddr,connectpass:string;
    servuserid,servhost,servergcos,servername:string;

    umode:integer;
    scannerenabled:boolean;
    scangduration:integer;
    scanreason:array[0..maxscanreason] of record
      p:string;
      s:string
    end;
    recvq,sendq:string;
    boottime:integer;
    rawconvorig:string;
    sop:array[0..maxsop] of string;
    loglastdate:integer;
    logmask:integer;
    logname:string;
    autogreet:string;
    msgcommand:string;
    safeidentify:boolean;
    {seen list}

    hiddenhost:boolean;
    cryptpass:boolean;

    seenlist:array[0..maxseen] of record
      mask:string;
      fullname:string;
      date:integer;
    end;
    currentseen:integer;
    {g-list}
    glist:array[0..maxglist] of record
      used:boolean;
      sender:string;
      mask:string;
      date:integer;
      reason:string;
    end;
    {jupe list}
    jupe:array[0..maxjupe] of record
      used:boolean;
      name:string;
      numeric:string;
      reason:string;
    end;
    chanmodeq:array[0..1023] of integer;
    chanmodeqcount:integer;
    forceflag:boolean;
    server:array[0..maxserver] of tserver;
    opermode:boolean;

    {nick and chan expire}
    nickexpire,chanexpire:integer;
    clonewarn,clonekill:integer;
    maxchanregs:integer;
    allownickreg,allowchanreg:boolean;
    reggednicks,reggedchannels:integer;
    diereason:string;
    wantstoconnect:boolean;

    operchannel:string;
  end;

var
  Form1: TForm1;
  logfile:textfile;

procedure doewords(s:string;var words:twords);
function convertidstr(const s:string):string;

procedure runapplication;

implementation

{$ifdef unix}
uses bunixsignals,unitfork;
{$endif}

procedure runapplication;
begin
  try
    form1 := tform1.Create(nil);
    form1.formcreate(form1);
  except
    on e:exception do writeln('error creating form1: ',e.message);
  end;

  {$ifdef unix}
  {$ifndef debug}dofork('bircserv');{$endif}
  writepid;
  bunixsignals.init;
  {$endif}

  messageloop;
  {$ifndef nowinnt}
  reportstopped;
  {$endif}
  form1.buttondieclick(nil);
  form1.savedb;
  {$ifndef nowinnt}
  reportstopped;
  {$endif}

  {$ifdef unix}
  deletepid;
  {$endif}
end;

function garbleoptional(s:string):string;
begin
  if form1.cryptpass then result := garble(s) else result := s;
end;

function p10inttostr(i,chars:integer):string;
const
  base64:array[0..63] of char='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789[]';
var
  a:integer;
begin
  if i >= 64 then if chars < 2 then chars := 2;

  setlength(result,chars);

  for a := chars downto 1 do begin
    result[a] := base64[i and 63];
    i := i shr 6;
  end;
end;

function p10strtoint(s:string):integer;
const
  base64reverse:array[0..255] of byte=(
  255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
  255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
  255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
  52,53,54,55,56,57,58,59,60,61,255,255,255,255,255,255,
  255,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,
  15,16,17,18,19,20,21,22,23,24,25,62,0,63,255,255,
  255,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,
  41,42,43,44,45,46,47,48,49,50,51,255,255,255,255,255,
  255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
  255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
  255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
  255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
  255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
  255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
  255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
  255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255
  );

var
  a,b,c:integer;
begin
  result := 0;
  b := 0;
  for a := length(s) downto 1 do begin
    c := base64reverse[ord(s[a])];
    if c = 255 then begin
      result := -1;
      exit;
    end;
    result := result or c shl b;
    inc(b,6);
  end;
end;

procedure tform1.sendoperchannel;
begin
  opersend('O '+operchannel+' :('+user[num].nick+') '+s);
end;

{
check if s2 matches s1, s1 may contain * ? wildcards, s2 may not
this is case sensitive, the caller should do uppercase (can be faster this way)
}
function maskmatch(s1,s2:string):boolean;
var
  a,b,c,d,ls1,ls2,count:integer;
  s3:string;
  goed,goed2:boolean;
begin
  if s2 = s1 then begin
    result := true;
    exit
  end;
  goed := true;
  s1 := #1 + s1 + #1;
  s2 := #1 + s2 + #1;
  ls1 := length(s1);
  ls2 := length(s2);
  a := 1;
  b := 1;
  while a <= ls1 do begin
    s3 := '';
    while (s1[a] <> '*') and (a<=ls1) do begin
      s3 := s3 + s1[a];
      inc(a);
    end;
    inc(a);
    count := ls2-length(s3)+1;
    goed2 := false;
    for c := b to count do begin
      goed2 := true;
      for d := 1 to length(s3) do begin
        if (s3[d] <> s2[d+c-1]) and ((s3[d] <> '?') or (s2[d+c-1] = #1)) then begin
          goed2 := false;
          break
        end
      end;
      if goed2 then begin
        break
      end;
    end;
    inc(b,length(s3));
    if not goed2 then begin
      result := false;
      exit;
    end;
  end;
  result := goed;
end;

function ircupper(const s:string):string;
{translate table for IRC uppercase}
const
  ircuppertable:array[0..255] of byte=(
  0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,
  16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,
  32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,
  48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,
  64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,
  80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,
  96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,
  80,81,82,83,84,85,86,87,88,89,90,91,92,93,126,127,
  128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,
  144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,
  160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,
  176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,
  192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,
  208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
  224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,
  240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
  );
{ recoded in pascal by plugwash as fpc didn't like the assembler stuff
  changed again by beware/simplifid/optimized 20030402}
var
  counter : integer;
begin
  result := s;
  for counter := length(result) downto 1 do begin
    result[counter] := char(ircuppertable[ord(result[counter])])
  end;
end;

procedure tform1.send(s:string);
begin
  if status = 0 then exit;
  if length(sendq)+length(s) > 1400 then sendflush;
  sendq := sendq + s+#13#10;
end;

procedure tform1.sendflush;
begin
  if sendq <> '' then begin
    sock.sendstr(sendq);
    sendq := '';
  end
end;

procedure tform1.mesend(s:string);
begin
  send(p10id+' '+s);
end;

procedure tform1.nicksend(s:string);
begin
  send(p10id+nickid+' '+s);
end;

procedure tform1.chansend(s:string);
begin
  send(p10id+chanid+' '+s);
end;

procedure tform1.memosend(s:string);
begin
  send(p10id+memoid+' '+s);
end;

procedure tform1.opersend(s:string);
begin
  send(p10id+operid+' '+s);
end;

{user is service operator}
procedure tform1.checksop(num:integer);
var
  a:integer;
  s:string;
begin
  user[num].sop := false;
  if not user[num].identified then exit;
  if not user[num].o then exit;
  s := ircupper(user[num].nick);
  for a := 0 to maxsop do if sop[a] <> '' then if maskmatch(ircupper(sop[a]),s) then begin
    user[num].sop := true;
    exit
  end;
end;

procedure tform1.checkmail(num:integer);
var
  a,b,c:integer;
  s:string;
begin
  if num < 0 then exit;
  if not useravail[num] then exit;
  if user[num].nsnum = -1 then exit;
  if not user[num].identified then exit;
  c := user[num].nsnum;
  if c = -1 then exit;
  if nickserv[c].privmsg then s := 'P ' else s := 'O ';
  b := 0;
  for a := 0 to maxmemo do if nickserv[c].memo[a].sender <> '' then inc(b);
  if b = 1 then memosend(s+user[num].idstr+' :You have one memo. Type /msg '+memonick+' READ 1 to read it.')
  else if b > 0 then memosend(s+user[num].idstr+' :You have '+inttostr(b)+' memos. Type /msg '+memonick+' LIST to see them.')
end;

function strtoint2(s:string;max:integer):longint;
var
  a:integer;
  goed:boolean;
begin
  goed := true;
  for a := 1 to length(s) do if not (s[a] in ['0'..'9']) then goed := false;
  if not goed or (length(s) > max) or (s = '') then begin
    strtoint2 := -1;
    exit;
  end;
  strtoint2 := strtoint(s);
end;

function tform1.nickaccess(usernum,nsnum:integer;password:string):integer;
var
  a:integer;
  goed:boolean;
begin
  result := -1;
  if nsnum = -1 then exit;
  result := 0;
  goed := false;
  for a := 0 to maxnaccess do if
  maskmatch(ircupper(nickserv[nsnum].mask[a]),ircupper(user[usernum].userid+'@'+user[usernum].host))
  or
  maskmatch(ircupper(nickserv[nsnum].mask[a]),ircupper(user[usernum].userid+'@'+user[usernum].ip))

  then begin
    goed := true;
    break
  end;
  if not goed then exit;
  result := 1;
  if garbleoptional(password) <> nickserv[nsnum].pass then exit;
  result := 2
end;

{
4=owner
3=sop
2=aop
1=voice
0=none
-1=akicked
}
procedure tform1.chanaccess(channum,usernum:integer;var cprivs:cprivsrec);
label label1,label2;
const
  lpr:array[0..3] of integer=(1,3,0,2);
  {priority SOP,AKICK,AOP,VOP}
var
  goed:boolean;
  a,c,d:integer;
  s,s2:string;
  cs:tchanserv;
begin
  {chanaccess does chanserv number, -1 means not registered}
  cprivs.registered := channum >= 0;
  goed := (usernum < 0);
  if not goed then if channum < 0 then goed := true;
  if goed then with cprivs do begin
    {chanserv must not do anything}
    level := 4;
    strictop := false;
    avoice:=false;
    aop := false;
    exit;
  end;
  c := channum;
  cs := chanserv[c];
  cprivs.level := 0;

  cprivs.founder := user[usernum].identified and (ircupper(cs.founder) = user[usernum].unick);
  if cprivs.founder then begin
    cprivs.level := 4;
    goto label2;
  end;
  if user[usernum].identified then begin
    s := user[usernum].unick;
    for a := 0 to maxsop do for d := 0 to 3 do if ircupper(cs.aop[lpr[d],a]) = s then begin
      if lpr[d] = 0 then cprivs.level := 2 else
      if lpr[d] = 1 then cprivs.level := 3 else
      if lpr[d] = 2 then cprivs.level := 1;
      goto label1
    end;
  end;
label1:
  if cprivs.level = 0 then begin
    s := ircupper(user[usernum].nick+'!'+user[usernum].userid+'@'+user[usernum].host);
    s2 := ircupper(user[usernum].nick+'!'+user[usernum].userid+'@'+user[usernum].ip);
    for a := 0 to maxsop do for d := 0 to 3 do if maskmatch(ircupper(cs.aop[lpr[d],a]),s) or maskmatch(ircupper(cs.aop[lpr[d],a]),s2) then begin
      if lpr[d] = 0 then cprivs.level := 2 else
      if lpr[d] = 1 then cprivs.level := 3 else
      if lpr[d] = 2 then cprivs.level := 1 else
      if lpr[d] = 3 then cprivs.level := -1;
      goto label2
    end;
  end;
label2:
  if cprivs.level < 2 then if user[usernum].o and chanserv[channum].operop then cprivs.level := 2;
  cprivs.strictop := cs.strictop;
  cprivs.avoice := cprivs.level >= 1;
  cprivs.aop := cprivs.level >= 2;
end;

function timeago(l:longint):string;
begin
  result := inttostr(l div 86400)+' days, '+inttostr(l div 3600 mod 24)+':'+inttostr(l div 600 mod 6)+
  inttostr(l div 60 mod 10)+':'+inttostr(l div 10 mod 6)+inttostr(l mod 10)
end;

function getlastmask(nsnum,num:integer):string;
var
  a:integer;
begin
  result := form1.nickserv[nsnum].lastmask;
  if form1.hiddenhost and not form1.user[num].o then begin
    a := pos('@',result);
    if a <> 0 then begin
      result := copy(result,1,a)+'hidden';
    end;
  end;
end;

procedure tform1.nicklist(sendtalk,match:string;max:integer;num:integer);
var
  matcharr:array[0..maxuser2] of boolean;
  s1,s2,s3:string;
  a,b,c,nummatch:integer;
  force:boolean;
begin
  force := user[num].sop;
  if max > 100 then max := 100;
  fillchar(matcharr,sizeof(matcharr),0);
  nummatch := 0;
  s1 := ircupper(match);
  for a := 0 to maxns do if nsavail[a] then if maskmatch(s1,nickserv[a].unick) then begin
    matcharr[a] := true;

    if not force then begin
      {dont match secret entries}
      if (nickserv[a].priv) then begin
        matcharr[a] := false;
      end;
    end;

    if matcharr[a] then inc(nummatch);
  end;
  s1 := '';
  b := 0;
  repeat
    s2 := #255;
    c := -1;
    for a := 0 to maxns do if matcharr[a] then begin
      s3 := nickserv[a].unick;
      if (s3 > s1) and (s3 < s2) then begin
        c := a;
        s2 := nickserv[c].unick;
      end;
    end;
    if (c <> -1) then begin
      s3 := '    '+nickserv[c].nick+' ';
      while length(s3) < 32 do s3 := s3 + ' ';
      if nickserv[c].num = -1 then
      send(sendtalk+s3+getlastmask(c,num))
      else send(sendtalk+s3+'<< ONLINE >>');
      s1 := nickserv[c].unick;
      matcharr[c] := false;
      inc(b);
    end;
  until (b >= max) or (b >= nummatch) or (c = -1);
  send(sendtalk+'End of list - '+inttostr(b)+'/'+inttostr(nummatch)+' matches shown.');
end;

procedure tform1.chanlist(sendtalk,match:string;max,num:integer);
var
  matcharr:array[0..maxchannel2] of boolean;
  s1,s2,s3:string;
  a,b,c,nummatch:integer;
  force:boolean;
begin
  force := user[num].sop;
  if max > 100 then max := 100;
  fillchar(matcharr,sizeof(matcharr),0);
  nummatch := 0;
  s1 := ircupper(match);
  for a := 0 to maxcs do if csavail[a] then if maskmatch(s1,chanserv[a].uname) then begin
    matcharr[a] := true;

    if not force then begin
      {dont match secret channels}
      if chanserv[a].num >= 0 then
      if (channel[chanserv[a].num].s)
      or channel[chanserv[a].num].p
      or (chanserv[a].priv) then begin
        matcharr[a] := false;
      end;
    end;
    if matcharr[a] then inc(nummatch);
  end;
  s1 := '';
  b := 0;
  repeat
    s2 := #255;
    c := -1;
    for a := 0 to maxcs do if matcharr[a] then begin
      s3 := chanserv[a].uname;
      if (s3 > s1) and (s3 < s2) then begin
        c := a;
        s2 := chanserv[c].uname;
      end;
    end;
    if (c <> -1) then begin
      s3 := '    '+chanserv[c].name+' ';
      while length(s3) < 32 do s3 := s3 + ' ';

      send(sendtalk+s3+chanserv[c].topic);

      s1 := chanserv[c].uname;
      matcharr[c] := false;
      inc(b);
    end;
  until (b >= max) or (b >= nummatch) or (c = -1);
  send(sendtalk+'End of list - '+inttostr(b)+'/'+inttostr(nummatch)+' matches shown.');
end;


function tform1.onignore(num1,num2:integer):boolean;
var
  a,c:integer;
begin
  result := false;
  for a := 0 to maxignore do if nickserv[num1].ignore[a] <> '' then begin
    c := getns(nickserv[num1].ignore[a]);
    if c <> -1 then if c = num2 then begin
      result := true;
      exit
    end;
  end;
end;

procedure tform1.loadoperserv;
var
  f:textfile;
  a:integer;
  glinecount,jupecount:integer;
  w:twords;
  s,s2,sv,sn:string;
begin
  {clear lists before loading them, glines, jupes}

  assignfile(f,'operserv.db');
  filemode := 0;
  {$i-}reset(f);{$i+}
  if ioresult = 0 then begin
    for a := 0 to maxglist do if glist[a].used then glist[a].used := false;
    for a := 0 to maxjupe do if jupe[a].used then jupe[a].used := false;
    for a := 0 to maxseen do seenlist[a].mask := '';
    currentseen := 0;

    glinecount := 0;
    jupecount := 0;
    while not eof(f) do begin
      readln(f,s);
      s2 := ircupper(s);
      a := pos('=',s);
      if a <> 0 then begin
        sv := copy(s2,1,a-1);
        sn := copy(s,a+1,length(s))
      end else sv := '';
      if sv = 'BOOTTIME' then begin
        boottime := strtointdef(sn,boottime);
      end;
      if sv = 'GLINE' then begin
        doewords(sn,w);
        if w[3] <> '' then begin
          glist[glinecount].used := true;
          glist[glinecount].sender := w[2];
          glist[glinecount].mask := w[0];
          glist[glinecount].date := strtointdef(w[1],0);
          a := pos(':',sn);
          glist[glinecount].reason := copy(sn,a+1,length(sn));
          inc(glinecount);
        end;
      end;
      if sv = 'JUPE' then begin
        doewords(sn,w);
        if w[2] <> '' then begin
          jupe[jupecount].used := true;
          jupe[jupecount].name := w[0];
          jupe[jupecount].numeric := w[1];
          a := pos(':',sn);
          jupe[jupecount].reason := copy(sn,a+1,length(sn));
          inc(jupecount);
        end;
      end;
      if sv = 'SEEN' then begin
        doewords(sn,w);
        if w[2] <> '' then begin
          inc(currentseen);
          currentseen := currentseen and maxseen;
          seenlist[currentseen].mask := w[0];
          seenlist[currentseen].date := strtointdef(w[1],0);
          a := pos(':',sn);
          seenlist[currentseen].fullname := copy(sn,a+1,length(sn));
        end;
      end;
    end;
    closefile(f);
  end;
end;

procedure tform1.saveoperserv;
var
  f:textfile;
  a,b:integer;
begin
  assignfile(f,'operserv.db');
  filemode := 2;
  rewrite(f);
  writeln(f,'BootTime='+inttostr(boottime));
  writeln(f);
  for a := 0 to maxglist do if glist[a].used then begin
    writeln(f,'Gline='+glist[a].mask+' '+inttostr(glist[a].date)+' '+glist[a].sender+' :'+glist[a].reason);
  end;
  writeln(f);
  for a := 0 to maxjupe do if jupe[a].used then begin
    writeln(f,'Jupe='+jupe[a].name+' '+jupe[a].numeric+' :'+jupe[a].reason);
  end;
  writeln(f);
  for a := 0 to maxseen do begin
    b := (a + currentseen+1) and maxseen;
    if seenlist[b].mask <> '' then begin
      writeln(f,'Seen='+seenlist[b].mask+' '+inttostr(seenlist[b].date)+' :'+seenlist[b].fullname);
    end;
  end;
  closefile(f);
end;

procedure tform1.loaddb;
begin
  loadnickserv;
  loadchanserv;
  loadoperserv;
end;


procedure tform1.savedb;
begin
  savenickserv;
  savechanserv;
  saveoperserv;
end;


{
nickserv access recover (random string)

security: (secure)
on: password && mask   password and mask needed; must identify to be recognised
off: password || mask   if mask matches, user is recognised. if not, user must identify

password is needed for "identified with password" flag,
is needed to change options, and to get access to secure channels
}

{
special privileges for chanserv

ircop and service op can always read privileged info such as AOP and SOP lists (but not the password)

service operator gets channel owner privileges on one channel after /msg chanserv admin #channel

service operator can do nickserv settings with the nick as extra parameter

Service operator can register unlimited channels, normal user can register n (1 or 2) channels.
}

procedure tform1.sendgline(s1:string;date:integer;reason:string);
begin
  mesend('GL * +'+s1+' '+inttostr(date)+' :Banned '+s1+' Until '+timestrshort(date+irctime-timezone)+' GMT ['+inttostr(irctime+date)+']: '+reason);
end;


procedure tform1.addgline(s1:string;date:integer;sender,s2:string);
var
  a,c:integer;
  s3:string;
begin
  s3 := ircupper(s1);
  c := -1;
  for a := 0 to maxglist do if glist[a].used then if ircupper(glist[a].mask) = s3 then c := a;
  if c = -1 then begin
    for a := 0 to maxglist do if not glist[a].used then begin
      glist[a].used := true;
      glist[a].sender := sender;
      glist[a].mask := s1;
      glist[a].date := date;
      glist[a].reason := s2;
      logwrite(logaddgline,'Added G-line: '+s1+' '+inttostr(date-irctime)+' '+s2);
      break
    end;
  end else begin
    glist[c].used := true;
    glist[c].sender := sender;
    glist[c].mask := s1;
    glist[c].date := date;
    glist[c].reason := s2;
    logwrite(logaddgline,'Reset expiration on G-line: '+s1+' '+inttostr(date-irctime)+' '+s2);
  end;
end;

procedure tform1.identify(num,nsnum:integer);
var
  a,b:integer;
  privs:cprivsrec;
begin
  nickserv[nsnum].lastmask := user[num].nick+'!'+user[num].userid+'@'+user[num].host;
  nickserv[nsnum].num := num;
  nickserv[nsnum].lastts := user[num].ts;
  nickserv[nsnum].gcos := user[num].gcos;
  user[num].identified := true;
  user[num].nagstatus := -1;
  user[num].nsnum := nsnum;
  nickserv[nsnum].lastdate := irctime;
  checksop(num);
  checkmail(num);
  for a := 0 to maxchanuser do if user[num].channel[a] > -1 then begin
    b := channel[user[num].channel[a]].csnum;
    if b >= 0 then begin
      chanaccess(b,num,privs);
      if privs.founder then begin
        chanserv[b].founderjoined := true;
        chanserv[b].lastdate := irctime;
      end;
      if privs.aop then setchanmode(user[num].channel[a],true,'o',user[num].idstr)
      else if privs.avoice then setchanmode(user[num].channel[a],true,'v',user[num].idstr);
    end;
  end;
end;

procedure tform1.killchannel(b:integer);
var
  a:integer;
begin
  flushallchanmode;
  opersend('J '+channel[b].name);
  opermode := true;
  setchanmode(b,true,'m','');
  setchanmode(b,true,'n','');
  setchanmode(b,true,'t','');
  setchanmode(b,true,'s','');
  setchanmode(b,true,'b','*!*@*');
  for a := 0 to channel[b].size-1 do if channel[b].userflag[a] and 2 <> 0 then begin
    if channel[b].user[a] >= 0 then setchanmode(b,false,'o',user[channel[b].user[a]].idstr);
  end;
  for a := 0 to channel[b].size-1 do if channel[b].userflag[a] and 1 <> 0 then begin
    if channel[b].user[a] >= 0 then setchanmode(b,false,'v',user[channel[b].user[a]].idstr);
  end;
  flushallchanmode;
  opermode := false;
end;



procedure tform1.bottalk(botnum,num:integer;s:string;nickatserver:boolean);
const
  mparams=99;
  wrongpass='Password incorrect.';
  wrongmask='Your mask does not match the ACCESS list, cannot identify.';
  nicknotreg='Your nick is not registered.';
  noprivsnick='Access denied. If this is your nick, type /msg NickServ IDENTIFY <password>';
  noprivschan='Access denied. No privileges for this channel. Try /msg NickServ IDENTIFY <password>';
  noprivschanown='Channel owner privileges required.';
  noprivschansop='Channel SOP privileges required.';
  noprivschanaop='Channel AOP privileges required.';
  noprivschanvop='Channel VOP privileges required.';
  aoplist:array[0..3] of byte=(3,4,3,3);
var
  sendcmd,sendtalk:string;
  mynick,m:string;
  words,words2:array[0..mparams] of string;
  nsnum:integer;
  goed:boolean;
  a,b,c,d,e,f:integer;
  s1,s2:string;
  privs:cprivsrec;
begin
  case botnum of
    0:begin
      mynick := nicknick;
      sendcmd := p10id+nickid+' ';
    end;
    1:begin
      mynick := channick;
      sendcmd := p10id+chanid+' ';
    end;
    2:begin
      mynick := memonick;
      sendcmd := p10id+memoid+' ';
    end;
    3:begin
      mynick := opernick;
      sendcmd := p10id+operid+' ';
    end;
  end;
  sendtalk := sendcmd + msgcommand+' '+user[num].idstr+' :';
  if user[num].floodtime < irctime then begin
    user[num].floodtime := irctime;
    user[num].floodtriggered := false;
  end;
  inc(user[num].floodtime,2);
  if (user[num].floodtime > irctime+14) and not user[num].floodtriggered and not user[num].o then begin
    send(sendtalk+'You are temporarily ignored for flooding.');
    mesend('WA :Temporary ignore for flood triggered on '+user[num].nick+'['+user[num].userid+'@'+user[num].host+']');
    user[num].floodtriggered := true;
    {flood triggered}
  end;
  if user[num].floodtriggered then exit;
  for a := 0 to mparams do begin
    words[a] := '';
    words2[a] := '';
  end;
  b := 0;
  a := 1;
  while (b < mparams) and (a <= length(s)) do begin
    if (s[a] <> ' ') and (s[a-1] = ' ') and (words[b] <> '') then inc(b);
    if (s[a] <> ' ') and not ((s[a] = ':') and (s[a-1] = ' ')) then words[b] := words[b] + s[a];
    inc(a)
  end;
  for a := 0 to b do words2[a] := ircupper(words[a]);
  nsnum := getns(user[num].unick);
  if user[num].nsnum > -1 then if nickserv[nsnum].privmsg then
  sendtalk := sendcmd + 'PRIVMSG '+user[num].idstr+' :';
  case botnum of
    0:begin
      if words2[0] = 'HELP' then begin
        if words2[1] = 'REGISTER' then begin
          send(sendtalk +'REGISTER <password> <email>');
          send(sendtalk +'Registers your nick. You must be using the nick which you want to register, and the nick must be available for registering.');
        end else if words2[1] = 'DROP' then begin
          send(sendtalk +'DROP <password>');
          send(sendtalk +'Removes your nick from the database. You then no longer own the nick, and it is available for other users. '+
          'A nick is automatically dropped if you don''t identify for 30 days.')
        end else if words2[1] = 'ACCESS' then begin
          send(sendtalk +'ACCESS ADD <mask>         Add a mask to the list');
          send(sendtalk +'ACCESS DEL <mask>         Remove a mask from the list');
          send(sendtalk +'ACCESS                    Show mask list');
          send(sendtalk +'Sets masks from which you can identify for the nick. '+
          'Masks are in the format userid@host. '+
          'When you register a nick, mask *@* is in the list as default.');
          send(sendtalk +'Be careful; by removing your mask, you can loose access to your nick.')
        end else if words2[1] = 'SET' then begin
          send(sendtalk +'SET EMAIL <email>');
          send(sendtalk +'   Set or change your email address');

          send(sendtalk +'SET URL <url>');
          send(sendtalk +'   Set or change your URL (homepage address)');
          send(sendtalk +'This is for informational purposes and it is visible to who does an INFO command on you.');
          send(sendtalk +'SET PASSWORD <oldpass> <newpass>');
          send(sendtalk +'   Changes your password');
          send(sendtalk +'SET PRIVMSG ON|OFF');
          send(sendtalk +'   Setting this to on causes services to send privmsg (/msg) messages to you rather than notice messages.');
          send(sendtalk +'SET PRIVATE ON|OFF');
          send(sendtalk +'   This setting hides your information from who doesn''t know your nick.');
        end else if words2[1] = 'IDENTIFY' then begin
          send(sendtalk +'IDENTIFY <password>');
          send(sendtalk +'Use this command to identify for your nick ')
        end else if words2[1] = 'GHOST' then begin
          send(sendtalk +'GHOST <nick> <password>');
          send(sendtalk +'Use this command to kill someone who is using your nick.');
        end else if words2[1] = 'RECOVER' then begin
          send(sendtalk +'RECOVER <nick> <password>');
          send(sendtalk +'Use this command to kill someone who is using your nick.');
        end else if words2[1] = 'IGNORE' then begin
          send(sendtalk +'IGNORE ADD <nick>');
          send(sendtalk +'IGNORE DEL <nick>');
          send(sendtalk +'IGNORE LIST');
          send(sendtalk +'Someone who is on your IGNORE list can''t send memoserv messages to you. (unless he is an IRCop)')
        end else if words2[1] = 'LIST' then begin
          send(sendtalk +'LIST <pattern> <number>');
          send(sendtalk +'Returns a list of registered nicks. Private nicks are not listed.');
        end else if words2[1] = 'INFO' then begin
          send(sendtalk +'Shows information about a registered nick. It also tells you if he has you on his ignore list.');
        end else begin
          send(sendtalk +'NickServ allows you to register a nickname. You then own the nickname. Having a registered nickname allows you to register channels, send and read memos, and stop other users from using your nick.');
          send(sendtalk +'NickServ commands');
          send(sendtalk +'====================================');
          send(sendtalk +'REGISTER    DROP        IDENTIFY');
          send(sendtalk +'RECOVER     GHOST       SET');
          send(sendtalk +'IGNORE      LIST        INFO');
          send(sendtalk +'Use HELP <command> to get more help about a command');
          send(sendtalk +'NickServ may not be abused to "steal" nicks. Doing so will result in, at least, loss of the registered nicks.');
          if nickexpire > 0 then send(sendtalk +'A nick is automatically dropped after not being used for '+inttostr(chanexpire)+' days.');
        end
      end else if words2[0] = 'REGISTER' then begin
        if words2[2] = '' then begin
          send(sendtalk+'Not enough parameters. Syntax is REGISTER <password> <email>');
          exit
        end;
        if not user[num].o then begin
          if not allownickreg then begin
            send(sendtalk+'Users can''t register their nick.');
            exit;
          end;
        end;
        if nsnum <> -1 then begin
          send(sendtalk+'This nick is already registered by someone. You can''t register it.');
          exit
        end;
        b := -1;
        for a := maxns+1 downto 0 do if not nsavail[a] then b := a;
        if b > maxns then maxns := b;
        if b = -1 then exit;
        nickserv[b] := tnickserv.create;
        nsavail[b] := true;
        setns(b,user[num].nick);
        nickserv[b].pass := garbleoptional(words[1]);
        nickserv[b].mask[0] := '*@*';
        send(sendtalk+'Your nick is now registered');
        nickserv[b].num := num;
        nickserv[b].regdate := irctime;
        nickserv[b].lastdate := irctime;
        nickserv[b].lastts := user[num].ts;
        nickserv[b].lastmask := user[num].nick+'!'+user[num].userid+'@'+user[num].host;
        nickserv[b].gcos := user[num].gcos;
        nickserv[b].email := words[2];
        nickserv[b].priv := false;
        user[num].nsnum := b;
        user[num].identified := true;
        inc(reggednicks);
        checksop(num);
      end else if words2[0] = 'IDENTIFY' then begin
        if safeidentify then if not nickatserver then begin
          send(sendtalk+'error: You can not use "/msg '+nicknick+'" to identify. Use "/msg '+nicknick+'@'+servername+'" or "/nickserv"');
          exit;
        end;
        if words2[1] = '' then begin
          send(sendtalk+'Not enough parameters. Syntax is IDENTIFY <password>');
          exit
        end;
        if nsnum = -1 then begin
          send(sendtalk+nicknotreg);
          exit
        end;
        a := nickaccess(num,nsnum,words[1]);
        if a = 0 then begin
          send(sendtalk+wrongmask);
          exit
        end else if a = 1 then begin
          send(sendtalk+wrongpass);
          exit
        end;
        send(sendtalk+'Password accepted, you are now recognized.');
        identify(num,nsnum);
      end else if (words2[0] = 'GHOST') or (words2[0] = 'RECOVER') then begin
        if words2[2] = '' then begin
          send(sendtalk+'Not enough parameters. Syntax is '+words2[0]+' <nick> <password>');
          exit
        end;
        c := getns(words2[1]);
        if c = -1 then begin
          send(sendtalk+words[1]+' is not a registered nickname');
          exit;
        end;
        a := nickaccess(num,c,words[2]);
        if a = 0 then begin
          send(sendtalk+wrongmask);
          exit
        end else if a = 1 then begin
          send(sendtalk+wrongpass);
          exit
        end;
        b := getnick(words2[1]);
        if b = -1 then begin
          send(sendtalk+'no such nick: '+words[1]);
          exit
        end;
        send(sendtalk+words[1]+' has been killed.');
        send(sendcmd+'D '+user[b].idstr+' :'+servername+'!'+nicknick+' (Kill requested by '+user[num].nick+')');
        removeuser(b);
      end else if words2[0] = 'ACCESS' then begin
        if not user[num].identified then begin
          send(sendtalk+noprivsnick);
          exit
        end;
        if words2[1] = 'ADD' then begin
          if words2[2] = '' then begin
            send(sendtalk+'Not enough parameters. Syntax is ACCESS ADD <mask>');
            exit
          end;
          b := -1;
          c := -1;
          for a := maxnaccess downto 0 do begin
            if nickserv[nsnum].mask[a] = '' then b := a;
            if ircupper(nickserv[nsnum].mask[a]) = words2[2] then c := a;
          end;
          if c <> -1 then begin
            send(sendtalk+words[2]+' mask is already in your ACCESS list.');
            exit
          end;
          if b = -1 then begin
            send(sendtalk+words[2]+' Your ACCESS list is full.');
            exit
          end;
          nickserv[nsnum].mask[b] := words[2];
          send(sendtalk+words[2]+' mask has been added to your ACCESS list.');
        end else if words2[1] = 'DEL' then begin
          if words2[2] = '' then begin
            send(sendtalk+'Not enough parameters. Syntax is ACCESS DEL <mask>');
            exit
          end;
          c := -1;
          for a := maxnaccess downto 0 do begin
            if ircupper(nickserv[nsnum].mask[a]) = words2[2] then c := a;
          end;
          if c = -1 then begin
            send(sendtalk+words[2]+' mask is not in your ACCESS list.');
            exit
          end;
          nickserv[nsnum].mask[c] := '';
          send(sendtalk+words[2]+' mask has been deleted from your ACCESS list.');
        end else begin
          goed := false;
          for a := 0 to maxnaccess do if nickserv[nsnum].mask[a] <> '' then begin
            goed := true;
            send(sendtalk+nickserv[nsnum].mask[a]);
          end;
          if goed then send(sendtalk+'End of ACCESS list') else send(sendtalk+'Your ACCESS list is empty');
        end;
      end else if words2[0] = 'DROP' then begin
        if words2[1] = '' then begin
          send(sendtalk+'Not enough parameters. Syntax is DROP <password>');
          exit
        end;
        a := nickaccess(num,nsnum,words[1]);
        if a = -1 then begin
          send(sendtalk+nicknotreg);
          exit
        end else if a = 0 then begin
          send(sendtalk+wrongmask);
          exit
        end else if a = 1 then begin
          send(sendtalk+wrongpass);
          exit
        end;
        {check for channel privileges}
        user[num].identified := false;
        user[num].nsnum := -1;
        nsavail[nsnum] := false;
        setns(nsnum,'');
        nickserv[nsnum].destroy;
        send(sendtalk+'Your nick has been unregistered.');
        dec(reggednicks);
      end else if words2[0] = 'SET' then begin
        if words2[1] = 'EMAIL' then begin
          if not user[num].identified then begin
            send(sendtalk+noprivsnick);
            exit
          end;
          nickserv[nsnum].email := words[2];
          send(sendtalk+'Your email information has been changed.');
        end else if words2[1] = 'URL' then begin
          if not user[num].identified then begin
            send(sendtalk+noprivsnick);
            exit
          end;
          nickserv[nsnum].url := words[2];
          send(sendtalk+'Your URL information has been changed.')
        end else if words2[1] = 'PASSWORD' then begin
          if nsnum = -1 then begin
            send(sendtalk+nicknotreg);
            exit
          end;
          a := nickaccess(num,nsnum,words[2]);
          if a = 0 then begin
            send(sendtalk+wrongmask);
            exit
          end else if a = 1 then begin
            send(sendtalk+wrongpass);
            exit
          end;
          nickserv[nsnum].pass := garbleoptional(words[3]);
          send(sendtalk+'Your password has been changed.')
        end else if words2[1] = 'PRIVMSG' then begin
          if not user[num].identified then begin
            send(sendtalk+noprivsnick);
            exit
          end;
          if (words2[2] <> 'OFF') and not nickserv[nsnum].privmsg then begin
            nickserv[nsnum].privmsg := true;
            send(sendtalk+'Services now send messages as PRIVMSG');
          end else if (words2[2] <> 'ON') and nickserv[nsnum].privmsg then begin
            nickserv[nsnum].privmsg := false;
            send(sendtalk+'Services now send messages as NOTICE');
          end
        end else if words2[1] = 'PRIVATE' then begin
          if not user[num].identified then begin
            send(sendtalk+noprivsnick);
            exit
          end;
          if (words2[2] <> 'OFF') and not nickserv[nsnum].priv then begin
            nickserv[nsnum].priv := true;
            send(sendtalk+'Your nick information is now private');
          end else if (words2[2] <> 'ON') and nickserv[nsnum].priv then begin
            nickserv[nsnum].priv := false;
            send(sendtalk+'Your nick information is no longer private');
          end
        end else begin
          send(sendtalk+'Invalid parameters. Syntax is SET <option>. Type /msg '+nicknick+' HELP SET for a list of valid options.');
          exit
        end;
      end else if words2[0] = 'IGNORE' then begin
        if not user[num].identified then begin
          send(sendtalk+noprivsnick);
          exit
        end;
        if words2[1] = 'ADD' then begin
          if words2[2] = '' then begin
            send(sendtalk+'Not enough parameters. Syntax is IGNORE ADD <nick>');
            exit
          end;
          b := -1;
          c := -1;
          for a := maxignore downto 0 do begin
            if nickserv[nsnum].ignore[a] = '' then b := a;
            if ircupper(nickserv[nsnum].ignore[a]) = words2[2] then c := a;
          end;
          if c <> -1 then begin
            send(sendtalk+'nick '+words[2]+' is already in your IGNORE list.');
            exit
          end;
          if b = -1 then begin
            send(sendtalk+'Your IGNORE list is full.');
            exit
          end;
          nickserv[nsnum].ignore[b] := words[2];
          send(sendtalk+words[2]+' nick has been added to your IGNORE list.');
        end else if words2[1] = 'DEL' then begin
          if words2[2] = '' then begin
            send(sendtalk+'Not enough parameters. Syntax is IGNORE DEL <nick|number>');
            exit
          end;
          c := -1;
          for a := maxignore downto 0 do begin
            if ircupper(nickserv[nsnum].ignore[a]) = words2[2] then c := a;
          end;
          if c = -1 then begin
            send(sendtalk+words[2]+' nick is not in your IGNORE list.');
            exit
          end;
          nickserv[nsnum].ignore[c] := '';
          send(sendtalk+words[2]+' nick has been deleted from your IGNORE list.')
        end else begin
          goed := false;
          b := 1;
          for a := 0 to maxignore do if nickserv[nsnum].ignore[a] <> '' then begin
            goed := true;
            s := inttostr(b);
            while length(s) < 4 do s := s + ' ';
            inc(b);
            send(sendtalk+s+nickserv[nsnum].ignore[a]);
          end;
          if goed then send(sendtalk+'End of IGNORE list') else send(sendtalk+'Your IGNORE list is empty');
        end;
      end else if words2[0] = 'INFO' then begin
        if words2[1] = '' then begin
          send(sendtalk+'Not enough parameters. Syntax is INFO <nick>');
          exit
        end;
        b := getns(words2[1]);
        if b = -1 then begin
          send(sendtalk+words[1]+' is not a registered nickname');
          exit
        end;
        if nickserv[b].priv and not ((nickserv[b].num = num) or user[num].o) then begin
          send(sendtalk+'information about nick '+words[1]+' is private');
          exit;
        end;

        if nickserv[b].gcos = '' then send(sendtalk+'Information about '+nickserv[b].nick)
        else send(sendtalk+nickserv[b].nick+' is '+nickserv[b].gcos);
        if nickserv[b].num = -1 then
        send(sendtalk+'Last seen address: '+getlastmask(b,num));
        if user[num].o then if (nickserv[b].email <> '') then send(sendtalk+'    Email Address: '+nickserv[b].email);
        if nickserv[b].url <> '' then send(sendtalk+'              URL: '+nickserv[b].url);
        send(sendtalk+'       Registered: '+timeago(irctime-nickserv[b].regdate)+' ago');
        if nickserv[b].num = -1 then
        send(sendtalk+'        Last seen: '+timeago(irctime-nickserv[b].lastdate)+' ago');
        if nickserv[b].num <> -1 then begin
          send(sendtalk+'This user is currently online, type /whois '+user[nickserv[b].num].nick+' for more information.');
        end;
        if user[num].identified then if onignore(b,nsnum) then begin
          send(sendtalk+'This user has you on ignore.');
        end;
      end else if words2[0] = 'LIST' then begin
        if words2[2] = '' then begin
          send(sendtalk+'Syntax: LIST <pattern> [max]');
          send(sendtalk+'Type /msg '+nicknick+' HELP LIST for more information.');
          exit
        end;
        nicklist(sendtalk,words[1],strtoint2(words[2],3),num);
      end else begin
        send(sendtalk +'Unknown command: '+words[0]+'. Type /msg '+nicknick+' HELP for a list of commands.')
      end;
    end;
    1: begin
      if words2[0] = 'HELP' then begin
        if words2[1] = 'REGISTER' then begin
          send(sendtalk +'REGISTER <channel> <password>');
          send(sendtalk +'Registers a channel. You must be channel operator in the channel. '+
          'You need the password again when you want to drop the channel, or when you want to give ownership to someone else.');
        end else if words2[1] = 'SET' then begin
          send(sendtalk +'SET URL                 Set or change the URL (homepage address) of the channel');
          send(sendtalk +'This information is for informational purposes and it is visible to whoever does an INFO command on you.');
          send(sendtalk +'SET PASSWORD            Sets the password (the owner needs it to drop the channel)');
          send(sendtalk +'SET WELCOME             Sets the text which is sent to joining users (autogreet)');
          send(sendtalk +'SET FOUNDER             Give ownership of the channel to someone else. The user must be online.');
          send(sendtalk +'SET STRICTOP ON|OFF     If set, users who don''t have auto-op level are automatically de-opped.');
          send(sendtalk +'SET PRIVATE ON|OFF      If set, the channel does not show in a wildcard search (LIST).');
          send(sendtalk +'SET OPEROP ON|OFF       If set, any IRC Operator has auto-op privileges');
          send(sendtalk +'SET OPERONLY ON|OFF     If set, only IRCops and users on the access list are allowed to join');
          send(sendtalk +'SET MODELOCK            Mode Lock is used to force modes to be set or cleared.');
        end else if words2[1] = 'CLEAR' then begin
          send(sendtalk +'CLEAR OP      Mass deop.');
          send(sendtalk +'CLEAR USER    Mass kick.');
          send(sendtalk +'CLEAR MODE    Remove channel modes.');
          send(sendtalk +'CLEAR BANS    Clear banlist.');
        end else if words2[1] = 'AOP' then begin
          send(sendtalk+'an AOP user has channel operator status and is able to use the INVITE command.');
          send(sendtalk+'SOP access is needed to modify the AOP list.');
          send(sendtalk +'AOP <channel> ADD <mask|nick>    adds a user to the AOP list');
          send(sendtalk +'AOP <channel> DEL <mask|nick>    removes a user from the AOP list');
          send(sendtalk +'AOP <channel> LIST               shows the AOP list');
        end else if words2[1] = 'SOP' then begin
          send(sendtalk+'a SOP user has channel operator status and is able to modify the AOP and the VOP list.');
          send(sendtalk+'Owner access is needed to modify the SOP list.');
          send(sendtalk +'SOP <channel> ADD <mask|nick>    adds a user to the SOP list');
          send(sendtalk +'SOP <channel> DEL <mask|nick>    removes a user from the SOP list');
          send(sendtalk +'SOP <channel> LIST               shows the SOP list');
        end else if words2[1] = 'VOP' then begin
          send(sendtalk+'a VOP user has voice (ability to speak on a moderated channel) and can use the INVITE command.');
          send(sendtalk+'SOP access is needed to modify the VOP list.');
          send(sendtalk +'VOP <channel> ADD <mask|nick>    adds a user to the VOP list');
          send(sendtalk +'VOP <channel> DEL <mask|nick>    removes a user from the VOP list');
          send(sendtalk +'VOP <channel> LIST               shows the VOP list');
        end else if words2[1] = 'AKICK' then begin
          send(sendtalk+'Users matching the AKICK list are not allowed to join the channel.');
          send(sendtalk+'SOP Access is needed to modify the AKICK list.');
          send(sendtalk +'AKICK <channel> ADD <mask|nick>    adds a user to the AKICK list');
          send(sendtalk +'AKICK <channel> DEL <mask|nick>    removes a user from the AKICK list');
          send(sendtalk +'AKICK <channel> LIST               shows the AKICK list');
        end else if words2[1] = 'OP' then begin
          send(sendtalk+'OP <channel> <nick>');
          send(sendtalk+'Gives a user channel operator status. If no nick is given, you are opped.');
        end else if words2[1] = 'DEOP' then begin
          send(sendtalk+'DEOP <channel> <nick>');
          send(sendtalk+'Takes channel operator status. If no nick is given, you are deopped.');
        end else if words2[1] = 'INFO' then begin
          send(sendtalk+'INFO <channel>');
          send(sendtalk+'Gives information about a registered channel.');
        end else if words2[1] = 'LIST' then begin
          send(sendtalk +'LIST <pattern> <number>');
          send(sendtalk +'Returns a list of registered channels. Private channels are not listed.');
        end else if words2[1] = 'INVITE' then begin
          send(sendtalk +'INVITE <channel>');
          send(sendtalk+'Makes '+channick+' invite you to a channel. Useful if your channel is invite only or you got accidentally banned. You need atleast VOP privileges on the channel.');
        end else if words2[1] = 'DROP' then begin
          send(sendtalk +'DROP <password>');
          send(sendtalk +'Removes the channel from the database. The channel is no longer registered to you, and it is available for other users to register it. '+
          'A channel is automatically dropped if the owner does not join for 30 days.')
        end else begin
          send(sendtalk +'Chanserv allows you to own and control a channel and prevents it from being taken over, without the need for a bot.');
          send(sendtalk +'ChanServ commands');
          send(sendtalk +'===================================');
          send(sendtalk +'REGISTER    DROP        SET');
          send(sendtalk +'SOP         AOP         VOP');
          send(sendtalk +'OP          DEOP        INVITE');
          send(sendtalk +'LIST        INFO        HELP');
          send(sendtalk +'CLEAR       AKICK       KICK');
          send(sendtalk +'Use HELP <command> to get more help about a command');
          if chanexpire > 0 then send(sendtalk +'A channel is automatically dropped if the owner does not join for '+inttostr(chanexpire)+' days.');
        end
      end else if words2[0] = 'INFO' then begin
        if words2[1] = '' then begin
          send(sendtalk+'Not enough parameters. Syntax is INFO <channel>');
          exit
        end;
        b := getcs(words2[1]);
        if b = -1 then begin
          send(sendtalk+'No such registered channel: '+words[1]);
{          send(sendtalk+'No information available about channel: '+words[1]);}
          exit
        end;

        chanaccess(b,num,privs);

        if not (user[num].o or (privs.level > 0)) then begin
          if chanserv[b].num >= 0 then begin
            if channel[chanserv[b].num].s then begin
              send(sendtalk+'No information available about channel: '+words[1]);
              exit;
            end;
          end;
        end;
        send(sendtalk+'Information about '+chanserv[b].name);
        if chanserv[b].url <> '' then send(sendtalk+'      URL: '+chanserv[b].url);
        send(sendtalk+'     Owner: '+chanserv[b].founder);
        if chanserv[b].founderjoined then
        send(sendtalk+' Is currently in the channel')
        else send(sendtalk+' Last seen: '+timeago(irctime-chanserv[b].lastdate)+' ago');
        send(sendtalk+'     Topic: '+chanserv[b].topic);
        if chanserv[b].welcome <> '' then send(sendtalk+'   Welcome: '+chanserv[b].welcome);
        send(sendtalk+'Registered: '+timeago(irctime-chanserv[b].regdate)+' ago');
        s1 := '';
        if chanserv[b].priv then s1 := s1 + 'Private, ';
        if chanserv[b].strictop then s1 := s1 + 'StrictOp, ';
        if chanserv[b].operop then s1 := s1 + 'OperOp, ';
        if chanserv[b].operonly then s1 := s1 + 'OperOnly, ';
        if s1 <> '' then s1 := copy(s1,1,length(s1)-2);
        if s1 <> '' then send(sendtalk+'   Options: '+s1);
        s1 := '';
        if chanserv[b].mlockyes <> '' then s1 := '+'+chanserv[b].mlockyes;
        if chanserv[b].mlockno <> '' then s1 := s1 + '-'+chanserv[b].mlockno;
        if s1 <> '' then send(sendtalk+'  ModeLock: '+s1);
      end else if words2[0] = 'LIST' then begin
        if words2[2] = '' then begin
          send(sendtalk+'Syntax: LIST <pattern> [max]');
          send(sendtalk+'Type /msg '+channick+' HELP LIST for more information.');
          exit
        end;
        chanlist(sendtalk,words[1],strtoint2(words[2],3),num);
      end else if words2[0] = 'REGISTER' then begin
        if words2[2] = '' then begin
          send(sendtalk+'Not enough parameters. Syntax is REGISTER <channel> <password>');
          exit
        end;
        if not user[num].o then begin
          if not allowchanreg then begin
            send(sendtalk+'Users can''t register a channel.');
            exit;
          end;
          {!!! limitation of number of channels}
          b := 0;
          for a := 0 to maxcs do if csavail[a] then if ircupper(chanserv[a].founder) = user[num].unick then inc(b);
        end;
        b := getchanname(words2[1]);
        if b < 0 then begin
          send(sendtalk+'You are not in that channel '+words[1]);
          exit
        end;
        if channel[b].csnum >= 0 then begin
          send(sendtalk+'channel '+channel[b].name+' is already registered. You can''t register it.');
          exit
        end;

        { find a +k on the channel}
        if not (user[num].o or user[num].sop) then begin
          for a := 0 to maxuserchan do begin
            if channel[b].user[a] >= 0 then if user[channel[b].user[a]].k then begin
              send(sendtalk+'channel '+channel[b].name+' is already registered. You can''t register it.');
              exit
            end;
          end;
        end;
        c := -1;
        for a := 0 to maxchanuser do begin
          if user[num].channel[a] = b then begin
            c := a;
            break;
          end;
        end;
        if c > -1 then if channel[b].userflag[user[num].channel2[c]] and 2 = 0 then c := -1;
        if c = -1 then begin
          send(sendtalk+'You must be channel operator in the channel to register it.');
          exit
        end;
        if not user[num].identified then begin
          send(sendtalk+'You must have a registered nick and have identified to register a channel.');
          exit
        end;

        c := 0;
        for a := 0 to maxcs do if csavail[a] then if ircupper(chanserv[a].founder) = user[num].unick then inc(c);

        if not user[num].o then if c >= maxchanregs then begin
          send(sendtalk+'You have already own the maximum allowed number of channels.');
          exit;
        end;

        c := -1;
        for a := maxcs+1 downto 0 do if not csavail[a] then c := a;
        if c > maxcs then maxcs := c;
        if c = -1 then exit;
        chanserv[c] := tchanserv.create;
        csavail[c] := true;
        setcs(c,channel[b].name);
        chanserv[c].password := garbleoptional(words[2]);
        if umode = 1 then begin
          {Undernet mode: chanserv is always member of a registered channel and gets opped by the server}
          chansend('J '+channel[b].name);
          mesend('M '+channel[b].name+' +o '+p10id+chanid);
        end;
        chanserv[c].ts := channel[b].ts;
        send(sendtalk+'Channel '+channel[b].name+' has been registered, you are now the owner of the channel.');
        chansend(msgcommand+' '+channel[b].name+' :This channel has been registered by '+user[num].nick);
        chansend('WA :Channel registration: '+channel[b].name+' by '+user[num].nick);
        chanserv[c].num := b;
        chanserv[c].regdate := irctime;
        chanserv[c].lastdate := irctime;

        chanserv[c].founder := nickserv[user[num].nsnum].nick;
        chanserv[c].topic := channel[b].topic;
        {defaults here}
        channel[b].csnum := c;
        inc(reggedchannels);
      end else if words2[0] = 'CLEAR' then begin
        if words2[2] = '' then begin
          send(sendtalk+'Not enough parameters. Syntax is CLEAR <channel> <option>');
          exit
        end;
        c := getcs(words2[1]);
        if c < 0 then begin
          send(sendtalk+'Channel '+words[1]+' is not registered.');
          exit
        end;
        chanaccess(c,num,privs);
        b := chanserv[c].num;
        if pos('USER',words2[2]) = 1 then begin
          if not (privs.level >= 3) then if not user[num].sop then begin
            send(sendtalk+noprivschansop);
            exit;
          end;
          if b >= 0 then begin
            chansend('O '+channel[b].name+' :'+user[num].nick+' issued CLEAR USER');
            for a := 0 to maxuserchan do begin
              d := channel[b].user[a];
              if d >= 0 then begin
                chansend('K '+channel[b].name+' '+user[d].idstr+' :Mass kick by '+user[num].nick);
                removeuserchannel(b,d);
                if not channelavail[b] then break;
              end;
            end;
          end;
        end else if pos('OP',words2[2]) = 1 then begin
          if not (privs.level >= 3) then if not user[num].sop then begin
            send(sendtalk+noprivschansop);
            exit;
          end;
          if b >= 0 then begin
            chansend('O '+channel[b].name+' :'+user[num].nick+' issued CLEAR OP');
            for a := 0 to maxuserchan do if channel[b].user[a] >= 0 then begin
              if (channel[b].userflag[a] and 2 <> 0) then setchanmode(b,false,'o',user[channel[b].user[a]].idstr);
            end;
          end;
        end else if pos('MODE',words2[2]) = 1 then begin
          if not (privs.level >= 2) then if not user[num].sop then begin
            send(sendtalk+noprivschanaop);
            exit;
          end;
          s1 := '';
          s2 := '';
          if b >= 0 then begin
            chansend('O '+channel[b].name+' :'+user[num].nick+' issued CLEAR MODE');
            if channel[b].k <> '' then begin
              s1 := s1 + 'k';
              s2 := s2 + ' '+channel[b].k
            end;
            if channel[b].l > 0 then s1 := s1 + 'l';
            if channel[b].i then s1 := s1 + 'i';
            if channel[b].m then s1 := s1 + 'm';
            if channel[b].s then s1 := s1 + 's';
            if channel[b].p then s1 := s1 + 'p';
            if s1 <> '' then chansend('M '+channel[b].name+' -'+s1+s2);
            channel[b].k := '';
            channel[b].l := 0;
            channel[b].i := false;
            channel[b].m := false;
            channel[b].s := false;
            channel[b].p := false;
          end;
        end else if pos('BAN',words2[2]) = 1 then begin
          if not (privs.level >= 2) then if not user[num].sop then begin
            send(sendtalk+noprivschanaop);
            exit;
          end;
          if b >= 0 then begin
            chansend('O '+channel[b].name+' :'+user[num].nick+' issued CLEAR BAN');
            for a := 0 to maxban do if channel[b].ban[a] <> '' then begin
              setchanmode(b,false,'b',channel[b].ban[a]);
              channel[b].ban[a] := '';
            end;
          end;
        end else begin
          send(sendtalk+'Invalid parameters. /msg '+channick+' HELP CLEAR for more information');
        end;
      end else if words2[0] = 'KICK' then begin
        if words2[2] = '' then begin
          send(sendtalk+'Not enough parameters. Syntax is KICK <channel> <nick>');
          exit
        end;
        {if words2[3] = '' then words[3] := 'bye bye';}
        c := getcs(words2[1]);
        if c < 0 then begin
          send(sendtalk+'Channel '+words[1]+' is not registered.');
          exit
        end;
        e := 0;
        chanaccess(c,num,privs);
        if privs.level < 2 then begin
          if user[num].sop then e := 1 else begin
            send(sendtalk+noprivschanaop);
            exit
          end
        end;
        b := chanserv[c].num;
        if b < 0 then exit; {the channel doesnt exist}
        d := getnick(words2[2]);
        if d < 0 then begin
          send(sendtalk+'No such nick.');
          exit;
        end;

        if user[d].k then begin
          send(sendtalk+user[d].nick+' is a service');
          exit;
        end;

        s2 := '';
        a := 3;
        while words2[a] <> '' do begin
          if s2 <> '' then s2 := s2 + ' ';
          s2 := s2 + words[a];
          inc(a);
        end;
        if s2 = '' then s2 := user[num].nick else s2 := '('+user[num].nick+') '+s2;
        for a := 0 to maxuserchan do if channel[b].user[a] = d then begin
          s1 := p10id+chanid+' K '+chanserv[c].name+' '+user[d].idstr+' :'+s2;
          send(s1);
          forceflag := true;
          parsecommand(s1);
        end;
      end else if words2[0] = 'DROP' then begin
        if words2[2] = '' then begin
          send(sendtalk+'Not enough parameters. Syntax is DROP <channel> <password>');
          exit
        end;
        c := getcs(words2[1]);
        if c < 0 then begin
          send(sendtalk+'Channel '+words[1]+' is not registered.');
          exit
        end;
        e := 0;
        chanaccess(c,num,privs);
        if privs.level < 4 then begin
          if user[num].sop then e := 1 else begin
            send(sendtalk+'You must be the owner of the channel and have identified.');
            exit
          end
        end;
        if (garbleoptional(words[2]) <> chanserv[c].password) then begin
          if user[num].sop then e := 1 else begin
            send(sendtalk+'password incorrect.');
            exit
          end
        end;
        if chanserv[c].num >= 0 then begin
          channel[chanserv[c].num].csnum := -1;
          chansend(msgcommand+' '+chanserv[c].name+' :This channel has been dropped by '+user[num].nick+'. It is no longer registered.');
          if umode = 1 then chansend('PART '+chanserv[c].name)
        end;
        if e = 1 then begin
          logwrite(logadmin,'Admin: channel '+chanserv[c].name+' dropped by '+user[num].nick);
        end;
        setcs(c,'');
        csavail[c] := false;
        chanserv[c].destroy;
        dec(reggedchannels);
      end else if words2[0] = 'SET' then begin
        if words2[2] = '' then begin
          send(sendtalk+'Not enough parameters. Syntax is SET <channel> <options>, use HELP SET for the list of options.');
          exit
        end;
        c := getcs(words2[1]);
        if c < 0 then begin
          send(sendtalk+'Channel '+words[1]+' is not registered.');
          exit
        end;
        chanaccess(c,num,privs);
        if words2[2] = 'MODELOCK' then begin
          if not (privs.level >= 3) then if not user[num].sop then begin
            send(sendtalk+noprivschan);
            exit
          end;
          parsemodelock(words[3],c);
          send(sendtalk+'The ModeLock of '+chanserv[c].name+' has been changed.')
        end else if words2[2] = 'URL' then begin
          if not (privs.level >= 3) then if not user[num].sop then begin
            send(sendtalk+noprivschan);
            exit
          end;
          chanserv[c].url := words[3];
          send(sendtalk+'The URL information of '+chanserv[c].name+' has been changed.')
        end else if words2[2] = 'PASSWORD' then begin
          if not (privs.level >= 4) then if not user[num].sop then begin
            send(sendtalk+noprivschan);
            exit
          end;
          if chanserv[c].password <> garbleoptional(words[3]) then begin
            send(sendtalk+'Password incorrect');
            exit;
          end;
          if words[4] = '' then begin
            send(sendtalk+'Not enough parameters. syntax is SET <channel> PASSWORD <oldpass> <newpass>');
            exit;
          end;
          chanserv[c].password := words[4];
          send(sendtalk+'The password of '+chanserv[c].name+' has been changed.')
        end else if words2[2] = 'PRIVATE' then begin
          if not (privs.level >= 3) then if not user[num].sop then begin
            send(sendtalk+noprivschan);
            exit
          end;
          if ((words2[3] = 'ON') or (words2[3] = '')) and not chanserv[c].priv then begin
            chanserv[c].priv := true;
            send(sendtalk+'Channel '+chanserv[c].name+' is now private');
          end else if ((words2[3] = 'OFF') or (words2[3] = '')) and chanserv[c].priv then begin
            chanserv[c].priv := false;
            send(sendtalk+'Channel '+chanserv[c].name+' is no longer private')
          end
        end else if words2[2] = 'STRICTOP' then begin
          if not (privs.level >= 3) then if not user[num].sop then begin
            send(sendtalk+noprivschan);
            exit
          end;
          if ((words2[3] = 'ON') or (words2[3] = '')) and not chanserv[c].strictop then begin
            chanserv[c].strictop := true;
            chansend(msgcommand+' '+chanserv[c].name+' :STRICTOP set to ON by '+user[num].nick);
            if chanserv[c].num <> -1 then begin
              b := chanserv[c].num;
              if b >= 0 then begin
                for a := 0 to maxuserchan do if channel[b].user[a] >= 0 then begin
                  chanaccess(c,channel[b].user[a],privs);
                  if not privs.aop then if not user[channel[b].user[a]].k then begin
                    if channel[b].userflag[a] and 2 <> 0 then setchanmode(b,false,'o',user[channel[b].user[a]].idstr);
                  end;
                end;
              end;
            end;
          end else if ((words2[3] = 'OFF') or (words2[3] = '')) and chanserv[c].strictop then begin
            chanserv[c].strictop := false;
            chansend(msgcommand+' '+chanserv[c].name+' :STRICTOP set to OFF by '+user[num].nick);
          end
        end else if words2[2] = 'OPEROP' then begin
          if not (privs.level >= 3) then if not user[num].sop then begin
            send(sendtalk+noprivschan);
            exit
          end;
          if ((words2[3] = 'ON') or (words2[3] = '')) and not chanserv[c].operop then begin
            chanserv[c].operop := true;
            chansend(msgcommand+' '+chanserv[c].name+' :OPEROP set to ON by '+user[num].nick);
          end else if ((words2[3] = 'OFF') or (words2[3] = '')) and chanserv[c].operop then begin
            chanserv[c].operop := false;
            chansend(msgcommand+' '+chanserv[c].name+' :OPEROP set to OFF by '+user[num].nick);
          end
        end else if words2[2] = 'OPERONLY' then begin
          if not (privs.level >= 3) then if not user[num].sop then begin
            send(sendtalk+noprivschan);
            exit
          end;
          if ((words2[3] = 'ON') or (words2[3] = '')) and not chanserv[c].operonly then begin
            chanserv[c].operonly := true;
            chansend(msgcommand+' '+chanserv[c].name+' :OPERONLY set to ON by '+user[num].nick);
          end else if ((words2[3] = 'OFF') or (words2[3] = '')) and chanserv[c].operonly then begin
            chanserv[c].operonly := false;
            chansend(msgcommand+' '+chanserv[c].name+' :OPERONLY set to OFF by '+user[num].nick);
          end
        end else if words2[2] = 'WELCOME' then begin
          if not (privs.level >= 3) then if not user[num].sop then begin
            send(sendtalk+noprivschan);
            exit
          end;
          s1 := '';
          a := 3;
          while (words[a] <> '') and (a <= mparams) do begin
            if s1 <> '' then s1 := s1 + ' ';
            s1 := s1 + words[a];
            inc(a);
          end;
          chanserv[c].welcome := s1;
          if s1 = '' then send(sendtalk+'Welcome message for '+chanserv[c].name+' has been cleared.')
          else send(sendtalk+'Welcome message for '+chanserv[c].name+' has been changed.')
        end else if (words2[2] = 'FOUNDER') or (words2[2] = 'OWNER') then begin
          e := 0;
          if not (privs.level >= 4) then if not user[num].sop then begin
            if user[num].sop then e := 1 else begin
              send(sendtalk+'You must be the owner of the channel and have identified to use this command.');
              exit
            end;
          end;
          a := getnick(words2[3]);
          if a >= 0 then if not user[a].identified then a := -1;
          if a = -1 then begin
            send(sendtalk+'The target user is not online or has not identified.');
            exit;
          end;
          chanserv[c].founder := nickserv[user[a].nsnum].nick;
          send(sendtalk+user[a].nick+' is now owner of '+chanserv[c].name);
          if nickserv[user[a].nsnum].privmsg then s1 := privmsgconst+' ' else s1 := noticeconst+' ';
          chansend(s1+user[a].idstr+' :'+user[num].nick+' has given you ownership of channel '+chanserv[c].name);
          if e = 1 then logwrite(logadmin,'Admin: channel '+chanserv[c].name+' owner changed to '+user[a].nick);
        end else begin
          send(sendtalk+'Invalid parameters. Syntax is SET <option>. Type /msg '+channick+' HELP SET for a list of valid options.');
          exit
        end;
      end else if (words2[0] = 'AOP') or (words2[0] = 'SOP') or (words2[0] = 'VOP') or (words2[0] = 'AKICK') then begin
        if words2[2] = '' then begin
          send(sendtalk+'Not enough parameters. /msg '+channick+' help '+words2[0]+' for more information.');
          exit
        end;
        c := getcs(words2[1]);
        if c < 0 then begin
          send(sendtalk+'Channel '+words[1]+' is not registered.');
          exit
        end;
        chanaccess(c,num,privs);
        if words2[0] = 'SOP' then e := 1 else
        if words2[0] = 'VOP' then e := 2 else
        if words2[0] = 'AOP' then e := 0 else e := 3;
        if words2[2] = 'ADD' then begin
          if words2[3] = '' then begin
            send(sendtalk+'Not enough parameters. Syntax is '+words2[0]+' <channel> ADD <nick|mask>');
            exit
          end;
          a := 0;
          if (privs.level < aoplist[e]) then if user[num].sop then a := 1 else begin
            send(sendtalk+'You don''t have privileges to modify the '+words2[0]+' list of '+chanserv[c].name);
            exit
          end;
          if a = 1 then begin
            logwrite(logadmin,'Admin: '+chanserv[c].name+' '+user[num].nick+': '+words[3]+' added to '+words2[0]+' list');
          end;

          b := -1;
          d := -1;
          for a := maxsop downto 0 do begin
            if chanserv[c].aop[e,a] = '' then b := a;
            if ircupper(chanserv[c].aop[e,a]) = words2[3] then d := a;
          end;
          if d <> -1 then begin
            send(sendtalk+'User '+words[3]+' is already in the '+words2[0]+' list of '+chanserv[c].name);
            exit
          end;
          if b = -1 then begin
            send(sendtalk+'The '+words2[0]+' list of '+chanserv[c].name+' is full.');
            exit
          end;
          chanserv[c].aop[e,b] := words[3];
          send(sendtalk+words[3]+' has been added to the '+words2[0]+' list of '+chanserv[c].name+'.');
        end else if words2[2] = 'DEL' then begin
          if words2[3] = '' then begin
            send(sendtalk+'Not enough parameters. Syntax is '+words2[0]+' <channel> DEL <nick|mask|number>');
            exit
          end;
          a := 0;
          if (privs.level < aoplist[e]) then if user[num].sop then a := 1 else begin
            send(sendtalk+'You don''t have privileges to modify the '+words2[0]+' list of '+chanserv[c].name);
            exit
          end;
          if a = 1 then begin
            logwrite(logadmin,'Admin: '+chanserv[c].name+' '+user[num].nick+': '+words[3]+' deleted from '+words2[0]+' list');
          end;
          b := strtointdef(words2[3],0);
          if b >= 1 then begin
            d := 0;
            for a := 0 to maxsop do begin
              if chanserv[c].aop[e,a] <> '' then inc(d);
              if d = b then begin
                send(sendtalk+chanserv[c].aop[e,a]+' has been removed from the '+words2[0]+' list of '+chanserv[c].name+'.');
                chanserv[c].aop[e,a] := '';
                exit
              end;
            end;
          end;
          d := -1;
          for a := maxsop downto 0 do begin
            if ircupper(chanserv[c].aop[e,a]) = words2[3] then d := a;
          end;
          if d = -1 then begin
            send(sendtalk+words[3]+' is not in the '+words2[0]+' list of '+chanserv[c].name);
            exit
          end;
          send(sendtalk+chanserv[c].aop[e,d]+' has been removed from the '+words2[0]+' list of '+chanserv[c].name+'.');
          chanserv[c].aop[e,d] := '';
          {if strictop then de-op user.}
        end else begin
          if (privs.level < 1) and (not user[num].o) then begin
            send(sendtalk+'VOP access required to view '+words2[0]+' list');
            exit
          end;
          goed := false;
          b := 0;
          for a := 0 to maxsop do begin
            s := chanserv[c].aop[e,a];
            if s <> '' then begin
              goed := true;
              inc(b);
              s2 := inttostr(b);
              while length(s2) < 4 do s2 := s2 + ' ';
              send(sendtalk+s2+s);
            end;
          end;
          if goed then send(sendtalk+'End of '+words2[0]+' list of '+chanserv[c].name)
          else send(sendtalk+words2[0]+' list of '+chanserv[c].name+' is empty.')
        end;
      end else if words2[0] = 'OPME' then begin
        if words2[1] <> '' then begin
          c := getcs(words2[1]);
          if c < 0 then begin
            send(sendtalk+'Channel '+words[1]+' is not registered.');
            exit
          end;
          chanaccess(c,num,privs);
          if privs.aop then begin
            goed := false;
            b := chanserv[c].num;
            if b >= 0 then begin
              for a := 0 to maxuserchan do if channel[b].user[a] = num then goed := true;
            end;
            if goed then setchanmode(b,true,'o',user[num].idstr);
          end else begin
            send(sendtalk+'You don''t have AOP privileges on channel '+chanserv[c].name);
          end;
        end else begin
          for a := 0 to maxchanuser do if user[num].channel[a] >= 0 then begin
            c := channel[user[num].channel[a]].csnum;
            if c >= 0 then begin
              chanaccess(c,num,privs);
              if privs.aop then setchanmode(user[num].channel[a],true,'o',user[num].idstr);
            end;
          end;
        end;
      end else if words2[0] = 'OP' then begin
        if words2[1] = '' then begin
          send(sendtalk+'Not enough parameters. syntax is OP <channel> <nick>');
          exit;
        end;
        if words2[2] = '' then begin
          words[2] := user[num].nick;
          words2[2] := user[num].unick;
        end;
        c := getcs(words2[1]);
        if c < 0 then begin
          send(sendtalk+'Channel '+words[1]+' is not registered.');
          exit
        end;
        if chanserv[c].num < 0 then exit;
        chanaccess(c,num,privs);
        e := 0;
        if not privs.aop then if user[num].sop then e := 1 else begin
          send(sendtalk+'AOP privileges on channel are required to use OP command.');
          exit
        end;
        if e = 1 then begin
          logwrite(logadmin,'Admin: '+user[num].nick+' uses chanserv OP on '+chanserv[c].name);
        end;
        a := getnick(words2[2]);
        if a = -1 then begin
          send(sendtalk+'No such nick: '+words[2]);
          exit;
        end;
        goed := false;
        for b := 0 to maxuserchan do if channel[chanserv[c].num].user[b] = a then begin
          goed := true;
          break
        end;
        if not goed then begin
          send(sendtalk+'User '+user[a].nick+' is not in channel '+chanserv[c].name);
          exit;
        end;
        if privs.strictop then begin
          chanaccess(c,a,privs);
          if not privs.aop then goed := false;
        end;
        if goed then begin
          setchanmode(chanserv[c].num,true,'o',user[a].idstr);
          chansend(msgcommand+' '+chanserv[c].name+' :'+user[num].nick+' issued OP');
        end else begin
          send(sendtalk+'This user cannot have ops on '+chanserv[c].name+' because of STRICTOP setting.');
        end;
      end else if words2[0] = 'DEOP' then begin
        if words2[1] = '' then begin
          send(sendtalk+'Not enough parameters. syntax is DEOP <channel> <nick>');
          exit;
        end;
        if words2[2] = '' then begin
          words[2] := user[num].nick;
          words2[2] := user[num].unick;
        end;
        c := getcs(words2[1]);
        if c < 0 then begin
          send(sendtalk+'Channel '+words[1]+' is not registered.');
          exit
        end;
        if chanserv[c].num < 0 then exit;
        chanaccess(c,num,privs);
        if not privs.aop then begin
          send(sendtalk+'AOP privileges on channel are required to use DEOP command.');
          exit
        end;
        a := getnick(words2[2]);
        if a = -1 then begin
          send(sendtalk+'No such nick: '+words[2]);
          exit;
        end;
        goed := false;
        for b := 0 to maxuserchan do if channel[chanserv[c].num].user[b] = a then begin
          goed := true;
          break
        end;
        if not goed then begin
          send(sendtalk+'User '+user[a].nick+' is not in channel '+chanserv[c].name);
          exit;
        end;
        if user[a].k then begin
          send(sendtalk+user[a].nick+' is a service');
          exit;
        end;
        chansend(msgcommand+' '+chanserv[c].name+' :'+user[num].nick+' issued DEOP');
        setchanmode(chanserv[c].num,false,'o',user[a].idstr);
      end else if words2[0] = 'INVITE' then begin
        if words2[1] = '' then begin
          send(sendtalk+'Not enough parameters. syntax is INVITE <channel>');
          exit
        end;
        c := getcs(words2[1]);
        if c < 0 then begin
          send(sendtalk+'Channel '+words[1]+' is not registered.');
          exit
        end;
        chanaccess(c,num,privs);
        if privs.level <= 0 then begin
          send(sendtalk+'No privileges on channel '+chanserv[c].name);
          exit
        end;
        chansend('INVITE '+user[num].nick+' '+chanserv[c].name);
      end else begin
        send(sendtalk +'Unknown command: '+words[0]+'. Type /msg '+channick+' HELP for a list of commands.')
      end;
    end;
    2: begin
      if words2[0] = 'HELP' then begin
        if words2[1] = 'SEND' then begin
          send(sendtalk +'SEND <nick> <message>');
          send(sendtalk +'Sends a message to the mailbox of the receipent. The receipent must be a registered nick.')
        end else if words2[1] = 'READ' then begin
          send(sendtalk +'READ <number>');
          send(sendtalk +'Displays a message from your mailbox')
        end else if words2[1] = 'DEL' then begin
          send(sendtalk +'DEL <number>');
          send(sendtalk +'Deletes a message from your mailbox')
        end else if words2[1] = 'CLEAR' then begin
          send(sendtalk +'CLEAR deletes all messages from your mailbox.');
        end else if words2[1] = 'LIST' then begin
          send(sendtalk +'LIST shows the messages in your mailbox, and who sent them, and how long ago.')
        end else begin
          send(sendtalk +'Memoserv allows leaving a message for someone who is not currently online. Both the sender and the receipent must have a registered nick.');
          send(sendtalk +'MemoServ commands');
          send(sendtalk +'===================================');
          send(sendtalk +'SEND        READ        DEL');
          send(sendtalk +'CLEAR       LIST        HELP');
          send(sendtalk +'Use HELP <command> to get more help about a command')
        end
      end else if words2[0] = 'SEND' then begin
        if words2[2] = '' then begin
          send(sendtalk+'Not enough parameters. Syntax is SEND <nick> <message>');
          exit;
        end;
        if not user[num].identified then begin
          send(sendtalk+noprivsnick);
          exit
        end;
        b := getns(words2[1]);
        if b = -1 then begin
          send(sendtalk+words[1]+' A message can only be sent to a registered nick.');
          exit
        end;
        if onignore(b,nsnum) then begin
          send(sendtalk+words[1]+' You are on this user''s IGNORE list.');
          exit
        end;
        c := -1;
        goed := true;
        for a := maxmemo downto 0 do if nickserv[b].memo[a].sender = '' then c := a else goed := false;
        if c = -1 then begin
          send(sendtalk+words[1]+'''s mailbox is full. Message not sent.');
          exit
        end;
        nickserv[b].memo[c].date := irctime;
        nickserv[b].memo[c].sender := nickserv[nsnum].nick;
        s1 := '';
        a := 2;
        while (words[a] <> '') and (a <= mparams) do begin
          s1 := s1 + words[a]+' ';
          inc(a);
        end;
        nickserv[b].memo[c].s := s1;
        send(sendtalk+'Message has been sent to '+words[1]+'''s mailbox');
        b := nickserv[b].num;
        if b <> -1 then if goed then checkmail(b);
      end else if words2[0] = 'LIST' then begin
        if not user[num].identified then begin
          send(sendtalk+noprivsnick);
          exit
        end;
        goed := false;
        for a := 0 to maxmemo do if nickserv[nsnum].memo[a].sender <> '' then goed := true;
        if goed then begin
          send(sendtalk+'Number  Sender  Time');
          for a := 0 to maxmemo do begin
            if nickserv[nsnum].memo[a].sender <> '' then begin
              s1 := inttostr(a+1);
              while length(s1) < 4 do s1 := s1 + ' ';
              s1 := s1+nickserv[nsnum].memo[a].sender+'   ';
              while length(s1) < 30 do s1 := s1 + ' ';
              b := (irctime-nickserv[nsnum].memo[a].date);
              s1 := s1 + timeago(b);
              send(sendtalk+s1)
            end;
          end;
          send(sendtalk+'Type /msg '+memonick+' READ <number> to read a message')
        end else begin
          send(sendtalk+'Your mailbox is empty.')
        end;
      end else if words2[0] = 'READ' then begin
        if not user[num].identified then begin
          send(sendtalk+noprivsnick);
          exit
        end;
        b := strtoint2(words2[1],3);
        if words2[1] = '' then begin
          c := 0;
          d := maxmemo;
        end else begin
          c := b-1;
          d := b-1;
          goed := false;
          if (c > maxmemo) or (d < 0) then goed := true;
          if not goed then if nickserv[nsnum].memo[c].sender = '' then goed := true;
          if goed then begin
            send(sendtalk +'There is no message number '+inttostr(b));
            exit
          end;
        end;
        goed := false;
        for a := c to d do if nickserv[nsnum].memo[a].sender <> '' then begin
          goed := true;
          send(sendtalk+'('+nickserv[nsnum].memo[a].sender+') '+nickserv[nsnum].memo[a].s);
        end;
        if not goed then begin
          send(sendtalk +'There are no messages.');
          exit
        end;
      end else if words2[0] = 'DEL' then begin
        if words2[1] = '' then begin
          send(sendtalk+'Not enough parameters. Syntax is DEL <number>');
          exit
        end;
        if not user[num].identified then begin
          send(sendtalk+noprivsnick);
          exit
        end;
        b := strtoint2(words2[1],3);
        dec(b);
        if (b < 0) or (b > maxmemo) then begin
          send(sendtalk +'There is no message number '+inttostr(b+1));
          exit;
        end;
        if nickserv[nsnum].memo[b].sender = '' then begin
          send(sendtalk+'There is no message number '+inttostr(b+1));
          exit
        end;
        nickserv[nsnum].memo[b].sender := '';
        nickserv[nsnum].memo[b].s := '';
        move(nickserv[nsnum].memo[b+1],nickserv[nsnum].memo[b],sizeof(nickserv[nsnum].memo[0])*(maxmemo-b));
        {fillchar(nickserv[nsnum].memo[maxmemo],sizeof(nickserv[nsnum].memo[maxmemo]),0);}
        nickserv[nsnum].memo[maxmemo].sender := '';
        send(sendtalk +'Message #'+inttostr(b+1)+' has been deleted');
      end else if words2[0] = 'CLEAR' then begin
        if not user[num].identified then begin
          send(sendtalk+noprivsnick);
          exit
        end;
        {fillchar(nickserv[nsnum].memo,sizeof(nickserv[nsnum].memo),0);}
        for b := 0 to maxmemo do nickserv[nsnum].memo[b].sender := '';
        send(sendtalk +'All messages have been deleted')
      end else begin
        send(sendtalk +'Unknown command: '+words[0]+'. Type /msg '+memonick+' HELP for a list of commands.')
      end;
    end;
    3: begin
      if words2[0] = 'HELP' then begin
        if not user[num].o then begin
          send(sendtalk+'HELP: You have no access to this command. IRC Operator required.');
          exit;
        end;
        send(sendtalk+'OperServ commands');
        send(sendtalk+'  MODE <parameters>    Forced mode change (channel hack)');
        send(sendtalk+'  RAW  <message>       Make the services send any raw command');
        send(sendtalk+'  NEWS <message>       Send a notice message to everyone on the network');
        send(sendtalk+'  GLINE +<nick|mask> <duration> <reason>');
        send(sendtalk+'    GLINE -<mask>      Add/remove a G-line. giving a nick will search *!*@host. duration can also be h, d, w, m, y (example: 2w means 2 weeks)');
        send(sendtalk+'  JUPE <add|list|del>  Set or remove jupe servers');
        send(sendtalk+'  SETNICKPASS <nick> <newpass>   Change the password of a registered nick (to be used in case of lost passwords)');
        send(sendtalk+'  NICKDROP <nick>      Drop a registered nick');
        send(sendtalk+'  RESET                Re-join and re-op chanserv, re-send G-lines, reset time.');
        send(sendtalk+'  SAVEDB               Save databases.');
        send(sendtalk+'  GLIST                Show G-lines');
        send(sendtalk+'  DISCONNECT           Disconnect the services from the network.');
        send(sendtalk+'  DIE                  terminate services.');
        send(sendtalk+'  INIT                 Disconnect, load the configuration and databases, connect');
        send(sendtalk+'  KILL <nick|channel>  Kill user, or all users in a channel');
        send(sendtalk+'  INVITE <channel>     Get yourself invited to a channel');
        send(sendtalk+'  KILLCHANNEL <name>   Terminates a channel (makes it unusable) but don''t kill users');
        send(sendtalk+'  OPTIONS * <params>   Send options message (params are the same format as bircd.ini)');
        {send(sendtalk+'  BANCHANNEL <add|list|del>  Permanently phrohibit a channel name mask');}
        {send(sendtalk+'  LOADDB               Re-load databases without services restart');
        send(sendtalk+'  LOADCS               Chanserv database reload');
        send(sendtalk+'  LOADCS               Nickserv database reload');}
        send(sendtalk+'  SEEN <nick|mask> [num]    Search through service''s seen list.');
      end else if words2[0] = 'SEEN' then begin
        if not user[num].o then begin
          send(sendtalk+'SEEN: You have no access to this command. IRC Operator required.');
          exit;
        end;
        if words2[1] = '' then words2[1] := '*';
        b := 0;
        d := 0;
        c := strtointdef(words2[2],10);
        a := currentseen;
        s1 := words2[1];
        if not ((pos('!',s1) > 0) or (pos('@',s1) > 0)) and ((pos('.',s1) = 0)) then s1 := s1 + '!*@*';
        repeat
          if maskmatch(s1,ircupper(seenlist[a].mask)) then begin
            if d < c then begin
              s2 := '';
              e := 9-length(inttostr(irctime-seenlist[a].date));
              while length(s2) < e do s2 := s2 + ' ';
              s2 := s2 + inttostr(irctime-seenlist[a].date)+' '+seenlist[a].mask+'   '+seenlist[a].fullname;

              send(sendtalk+s2);
              inc(d);
            end;
            inc(b);
          end;
          a := (a-1);
          if a < 0 then a := maxseen;
        until (a = currentseen);
        if b = 0 then begin
          send(sendtalk+'i can''t remember seeing '+words[1]);
        end else begin
          send(sendtalk+inttostr(d)+' of '+inttostr(b)+' entries listed.');
        end;
      end else if words2[0] = 'GLIST' then begin
        send(sendtalk+'G-lines - mask expiration sender reason');
        for a := 0 to maxglist do if glist[a].used then begin
          send(sendtalk+glist[a].mask+' <'+timestrshort(glist[a].date-timezone)+' '+glist[a].sender+'> '+glist[a].reason);
        end;
      end else if words2[0] = 'SERVERS' then begin
        {if user[num].sop then begin}
          send(sendtalk+'servers on network - num name');
          for a := 0 to maxserver do if server[a].used then begin
            send(sendtalk+inttostr(a)+' '+p10inttostr(server[a].p10id,2)+' '+server[a].name+' '+inttostr(server[a].parentserver));
          end;
   {     end;}
      end else if words2[0] = 'CHANNELS' then begin
        if not user[num].o then begin
          send(sendtalk+'CHANNELS: You have no access to this command. IRC Operator required.');
          exit;
        end;
        send(sendtalk+'Channels on network - name chanserv TS size users');
        for a := 0 to maxchannel do if channelavail[a] then begin
          s := channel[a].name+' '+inttostr(channel[a].csnum)+' '+inttostr(channel[a].ts)+' '+inttostr(channel[a].size);
          for b := 0 to maxuserchan do if channel[a].user[b] >= 0 then begin
            s := s + ' ';
            if channel[a].userflag[b] and 2 <> 0 then s := s + '@' else if channel[a].userflag[b] and 1 <> 0 then s := s + '+';
            s := s + user[channel[a].user[b]].nick;
            if length(s) > 400 then begin
              send(sendtalk+s);
              s := '';
            end;
          end;
          if s <> '' then send(sendtalk+s);
        end;
      end else if words2[0] = 'USERS' then begin
        if not user[num].o then begin
          send(sendtalk+'USERS: You have no access to this command. IRC Operator required.');
          exit;
        end;
        send(sendtalk+'Users on network - nick nickserv server TS numeric channels');
        if words2[1] = '' then words2[1] := '*';
        for a := 0 to maxuser do if useravail[a] then begin
          if maskmatch(words2[1],user[a].unick) then begin
            s := user[a].nick+' '+inttostr(user[a].nsnum)+' '+inttostr(user[a].servernum)+' '+inttostr(user[a].ts)+' '+user[a].idstr;
            for b := 0 to maxchanuser do if user[a].channel[b] >= 0 then begin
              s := s + ' ';
              c := channel[user[a].channel[b]].userflag[user[a].channel2[b]];
              if c and 2 <> 0 then s := s + '@' else if c and 1 <> 0 then s := s + '+';
              s := s + channel[user[a].channel[b]].name;
            end;
            send(sendtalk+s);
          end;
        end;
      end else if words2[0] = 'CHANINFO' then begin
        if not user[num].o then begin
          send(sendtalk+'CHANINFO: You have no access to this command. IRC Operator required.');
          exit;
        end;
        b := getchanname(words2[1]);
        if b = -1 then begin
          send(sendtalk+'no such channel: '+words[1]);
          exit;
        end;
        s1 := '+';
        s2 := '';
        if channel[b].n then s1 := s1 + 'n';
        if channel[b].t then s1 := s1 + 't';
        if channel[b].m then s1 := s1 + 'm';
        if channel[b].p then s1 := s1 + 'p';
        if channel[b].s then s1 := s1 + 's';
        if channel[b].i then s1 := s1 + 'i';
        if channel[b].k <> '' then begin
          s1 := s1 + 'k';
          s2 := s2 + ' '+channel[b].k;
        end;
        if channel[b].l <> 0 then begin
          s1 := s1 + 'l';
          s2 := s2 + ' '+inttostr(channel[b].l);
        end;
        send(sendtalk+channel[b].name+' modes: '+s1+s2);
        send(sendtalk+channel[b].name+' TS: '+inttostr(channel[b].ts)+' ('+timestrshort(channel[b].ts-timezone)+')');
        send(sendtalk+'Banlist of '+channel[b].name);
        for a := 0 to maxban do if channel[b].ban[a] <> '' then begin
          send(sendtalk+'  '+channel[b].ban[a]);
        end;
      end else if words2[0] = 'KILL' then begin
        if not user[num].o then begin
          send(sendtalk+'KILL: You have no access to this command. IRC Operator required.');
          exit;
        end;
        if not user[num].identified then begin
          send(sendtalk+'You have to be identied to use this command.');
          exit;
        end;
        s1 := '';
        a := 2;
        while words2[a] <> '' do begin
          if s1 <> '' then s1 := s1 + ' ';
          s1 := s1 + words[a];
          inc(a);
        end;
        sendoperchannel(num,'KILL '+words[1]+' '+s1);
        if s1 = '' then s1 := user[num].nick+')'
        else s1 := '('+user[num].nick+') '+s1+')';

        b := getnick(words2[1]);
        if b = -1 then begin
          b := getchanname(words2[1]);
          if b >= 0 then begin
            for a := 0 to maxuserchan do begin
              if channel[b].user[a] >= 0 then begin
                if not user[channel[b].user[a]].o then begin
                  send(sendcmd+'D '+user[channel[b].user[a]].idstr+' :'+servername+'!'+opernick+' ('+s1);
                  removeuser(channel[b].user[a]);
                end;
              end;
            end;
          end;
        end else begin
          send(sendcmd+'D '+user[b].idstr+' :'+servername+'!'+opernick+' ('+s1);
          removeuser(b);
        end;
        {if words2[1] = '' then exit;
        getchanname(words2[1]);}
        {send(sendcmd+'KILL '+words[1]+' :'+servername+'!'+nicknick+' (Kill requested by '+user[num].nick+')');}
      end else if words2[0] = 'INVITE' then begin
        if not user[num].o then begin
          send(sendtalk+'INVITE: You have no access to this command. IRC Operator required.');
          exit;
        end;
        if not user[num].identified then begin
          send(sendtalk+'You have to be identied to use this command.');
          exit;
        end;
        sendoperchannel(num,'INVITE '+words[1]);
        send(sendcmd+'I '+user[num].nick+' '+words[1]);
      end else if words2[0] = 'TIME' then begin
        send(sendtalk+timestrshort(irctime-timezone)+' GMT ('+inttostr(irctime)+')');
      end else if words2[0] = 'WHOIS' then begin
        (*if not user[num].o then begin
          send(sendtalk+'WHOIS: You have no access to this command. IRC Operator required.');
          exit;
        end;*)
        a := getnick(words2[1]);
        if a = -1 then begin
          send(sendtalk+words[1]+': No such nick');
          exit;
        end;
        if user[num].o then begin
          send(sendtalk+user[a].nick+' ('+user[a].userid+'@'+user[a].host+')');
          s1 := '+';
          if user[a].o then s1 := s1 + 'o';
          if user[a].i then s1 := s1 + 'i';
          if user[a].d then s1 := s1 + 'd';
          if user[a].w then s1 := s1 + 'w';
          if user[a].s then s1 := s1 + 's';
          if user[a].k then s1 := s1 + 'k';
          if user[a].g then s1 := s1 + 'g';
          if s1 <> '+' then send(sendtalk+'  modes: '+s1);
        end else send(sendtalk+user[a].nick);
        if user[num].o then send(sendtalk+'  numeric: '+user[a].idstr);
        if getns(user[a].nick) >= 0 then begin
          if user[a].identified then send(sendtalk+'  Has identified')
          else begin
            if user[a].maskmatch then send(sendtalk+'  Has not identified but mask matches ACCESS list')
            else send(sendtalk+'  Has not identified and mask does not match ACCESS list');
          end;
        end else send(sendtalk+'  Is not a registered nick');
        if user[a].sop then send(sendtalk+'  Is Services Operator and IRC operator') else
        if user[a].o then send(sendtalk+'  Is IRC Operator');
      end else if words2[0] = 'NEWS' then begin
        if not user[num].o then begin
          send(sendtalk+'NEWS: You have no access to this command. IRC Operator required.');
          exit;
        end;
        s1 := '';
        a := 1;
        while (words[a] <> '') and (a <= mparams) do begin
          s1 := s1 + words[a]+' ';
          inc(a);
        end;
        send(':'+opernick+' PRIVMSG $* :'+s1+'<'+user[num].nick+'>');
      end else if words2[0] = 'SETTIME' then begin
        if not user[num].o then begin
          send(sendtalk+'SETTIME: You have no access to this command');
          exit;
        end;
        if user[num].sop then begin
          if words2[1] <> '' then begin
            a := 0;
            if words2[1,1] = '-' then a := -1 else if words2[1,1] = '+' then a := 1;
            if a <> 0 then begin
              b := strtointdef(copy(words2[1],2,length(words2[1])),0);
              settime(irctime+a*b);
              irctime := irctimeint;
              send(sendtalk+'Time adjusted '+inttostr(a*b)+' seconds.');
            end;
          end;
        end;
        sendoperchannel(num,'SETTIME '+words[1]);
        mesend('SE :'+inttostr(irctime));
      end else if words2[0] = 'GLINE' then begin
        if not user[num].o then begin
          send(sendtalk+'GLINE: You have no access to this command. Services Operator required.');
          exit;
        end;
        if words[1] = '' then begin
          send(sendtalk+'Not enough parameteres');
          exit;
        end;
        goed := true;
        if words[1,1] = '+' then begin
          words[1] := copy(words[1],2,length(words[1]));
          words2[1] := ircupper(words[1])
        end;
        if words[1,1] = '-' then begin
          goed := false;
          words[1] := copy(words[1],2,length(words[1]));
          words2[1] := ircupper(words[1])
        end;
        if goed then if words[3] = '' then begin
          send(sendtalk+'Not enough parameteres');
          exit;
        end;

        if goed then begin
          a := getnick(words2[1]);
          if a <> -1 then begin
            s1 := '*@'+user[a].host;
          end else begin
            s1 := words[1];
          end;
          if pos('@',s1) = 0 then s1 := '*@' + s1;

          s2 := words2[2,length(words2[2])];
          if s2 = 'H' then b := 3600 else
          if s2 = 'D' then b := 86400 else
          if s2 = 'W' then b := 86400*7 else
          if s2 = 'M' then b := 86400*30 else
          if s2 = 'Y' then b := 86400*365 else b := 1;
          if b = 1 then b := strtoint2(words2[2],10)
          else b := b * strtoint2(copy(words2[2],1,length(words2[2])-1),10);
          if (b+irctime) < 0 then b := maxlongint-irctime;
          if ((b <= 0) or (b+irctime < 0)) or ((b > 86400) and not user[num].sop) then begin
            send(sendtalk+'Invalid duration');
            exit;
          end;
          s2 := '';
          a := 3;
          while (words[a] <> '') and (a <= mparams) do begin
            if s2 <> '' then s2 := s2 + ' ';
            s2 := s2 + words[a];
            inc(a);
          end;
        end else s1 := words[1];
        if not goed then begin
          mesend('GL * -'+s1);
          s1 := ircupper(s1);
          if pos('@',s1) = 0 then s1 := '*@' + s1;
          for a := 0 to maxglist do if glist[a].used then if ircupper(glist[a].mask) = s1 then begin
            glist[a].used := false;
            sendoperchannel(num,'GLINE -'+glist[a].mask+' ('+glist[a].reason+')');
            logwrite(logremovegline,'G-line removed: '+glist[a].mask+' '+inttostr(glist[a].date)+' '+glist[a].reason);
          end;
        end else begin
          sendoperchannel(num,'GLINE '+s1+' '+words[2]+' '+s2);
          sendgline(s1,b,s2);
          addgline(s1,irctime+b,user[num].nick,s2);
        end
      end else if words2[0] = 'KILLCHANNEL' then begin
        if not user[num].o then begin
          send(sendtalk+'KILLCHANNEL: You have no access to this command. IRC Operator required.');
          exit;
        end;
        if words2[1] = '' then begin
          send(sendtalk+'Give a channel name');
          exit
        end;
        b := getchanname(words2[1]);
        if b < 0 then begin
          send(sendtalk+'Channel does not exist');
          exit
        end;
        sendoperchannel(num,'KILLCHANNEL '+channel[b].name);
        killchannel(b);

        {flushallchanmode;
        opermode := true;
        setchanmode(b,true,'m','');
        setchanmode(b,true,'i','');
        setchanmode(b,true,'n','');
        setchanmode(b,true,'t','');
        setchanmode(b,true,'s','');
        for a := 0 to channel[b].size-1 do if channel[b].userflag[a] and 2 <> 0 then begin
          if channel[b].user[a] >= 0 then setchanmode(b,false,'o',user[channel[b].user[a]].nick);
        end;
        for a := 0 to channel[b].size-1 do if channel[b].userflag[a] and 1 <> 0 then begin
          if channel[b].user[a] >= 0 then setchanmode(b,false,'v',user[channel[b].user[a]].nick);
        end;
        flushallchanmode;
        opermode := false;}
      end else if words2[0] = 'RAW' then begin
        if not user[num].sop then begin
          send(sendtalk+'RAW: You have no access to this command. Services Operator required.');
          exit;
        end;
        a := 1;
        while (words[a] <> '') and (a <= mparams) do begin
          if s1 <> '' then s1 := s1 + ' ';
          s1 := s1 + words[a];
          inc(a);
        end;
        sendoperchannel(num,'RAW '+s1);
        logwrite(logadmin,'Admin: RAW from '+user[num].nick+': '+s1);
        send(s1);
        forceflag := true;
        parsecommand(s1);
      end else if words2[0] = 'OPTIONS' then begin
        if not user[num].sop then begin
          send(sendtalk+'OPTIONS: You have no access to this command. Services Operator required.');
          exit;
        end;
        if words[2] = '' then begin
          send(sendtalk+'Not enough parameters.');
          exit;
        end;
        a := 1;
        while (words[a] <> '') and (a <= mparams) do begin
          if s1 <> '' then s1 := s1 + ' ';
          s1 := s1 + words[a];
          inc(a);
        end;
        sendoperchannel(num,'OPTIONS '+s1);
        logwrite(logadmin,'Admin: OPTIONS from '+user[num].nick+': '+s1);
        mesend('OPTIONS '+s1);
      end else if words2[0] = 'MODE' then begin
        if not user[num].sop then begin
          send(sendtalk+'MODE: You have no access to this command. Services Operator required.');
          exit;
        end;
        if words[2] = '' then begin
          send(sendtalk+'Not enough parameters.');
        end;

        s1 := '';
        s2 := '';
        a := 1;
        while (words[a] <> '') and (a <= mparams) do begin
          if s1 <> '' then s1 := s1 + ' ';
          if s2 <> '' then s2 := s2 + ' ';
          s2 := s2 + words[a];
          b := getnick(words2[a]);
          if b >= 0 then words[a] := user[b].idstr;
          s1 := s1 + words[a];
          inc(a);
        end;

        sendoperchannel(num,'MODE '+s2);
        logwrite(logadmin,'Admin: MODE from '+user[num].nick+': '+s2);

        mesend('M '+s1);
        forceflag := true;
        parsecommand(p10id+' M '+s1);
      end else if words2[0] = 'SETNICKPASS' then begin
        if not user[num].sop then begin
          send(sendtalk+'SETNICKPASS: You have no access to this command. Services Operator required.');
          exit;
        end;
        if words[2] = '' then begin
          send(sendtalk+'Not enough parameters.');
          exit;
        end;
        b := getns(words2[1]);
        if b = -1 then begin
          send(sendtalk+'No such registered nick: '+words[1]);
          exit;
        end;
        sendoperchannel(num,'SETNICKPASS '+words[1]);
        nickserv[b].pass := garbleoptional(words[2]);
        send(sendtalk+'Nickserv password of '+words[1]+' has been changed.');
      end else if words2[0] = 'NICKDROP' then begin
        if not user[num].sop then begin
          send(sendtalk+'NICKDROP: You have no access to this command. Services Operator required.');
          exit;
        end;
        if words[1] = '' then begin
          send(sendtalk+'Not enough parameters.');
          exit;
        end;
        b := getns(words2[1]);
        if b = -1 then begin
          send(sendtalk+'No such registered nick: '+words[1]);
          exit;
        end;
        sendoperchannel(num,'NICKDROP '+words[1]);
        send(sendtalk+'Nick '+words[1]+' has been unregistered.');
        c := nickserv[b].num;
        if c >= 0 then begin
          user[c].identified := false;
          user[c].nsnum := -1;
        end;
        nsavail[b] := false;
        setns(b,'');
        nickserv[b].destroy;
        dec(reggednicks);
      end else if words2[0] = 'JUPE' then begin
        if not user[num].sop then begin
          send(sendtalk+'JUPE: You have no access to this command. Services Operator required.');
          exit;
        end;
        if words[1] = '' then begin
          send(sendtalk+'Not enough parameters.');
          exit;
        end;
        b := -1;
        c := -1;
        for a := 0 to maxjupe do begin
          if not jupe[a].used then b := a;
          if jupe[a].used then if ircupper(jupe[a].name) = words2[2] then c := a;
        end;
        if words2[1] = 'ADD' then begin
          for a := 0 to maxserver do if server[a].used then if server[a].uname = words2[2] then begin
            send(sendtalk+'server '+words[2]+' is currently on the network, remove it before adding the jupe');
            exit;
          end;
          if length(words[3]) = 1 then words[3] := 'A'+words[3];
          if length(words[3]) <> 2 then begin
            send(sendtalk+'Invalid numeric');
            exit;
          end;
          a := p10strtoint(words[3]);
          if (a < 0) or (a > 4095) then exit;
          if p10reverseserver[a] >= 0 then begin
            send(sendtalk+'numeric is already used by another server');
            exit; {already used by server}
          end;

          for a := 0 to maxjupe do if jupe[a].used then if (jupe[a].numeric = words[3]) or (ircupper(jupe[a].name) = words2[2]) then begin
            send(sendtalk+'name or numeric is already used by another jupe');
            exit; {already used by jupe}
          end;
          if b <> -1 then begin
            jupe[b].used := true;
            jupe[b].name := words[2];
            jupe[b].numeric := words[3];
            s1 := '';
            a := 4;
            repeat
              s1 := s1 + words[a]+' ';
              inc(a);
            until words[a] = '';
            jupe[b].reason := s1;
          end;
          mesend('S '+jupe[b].name+' 2 '+inttostr(boottime)+' '+inttostr(irctime)+' P10 '+jupe[b].numeric+'AAA 0 :JUPE '+jupe[b].reason);
          send(sendtalk+'Jupe added');
        end else if words2[1] = 'DEL' then begin
          if c <> -1 then begin
            mesend('SQ '+jupe[c].name+' 0 :Jupe removed by '+user[num].nick);
            jupe[c].used := false;
            send(sendtalk+'Jupe removed');
          end else begin
            send(sendtalk+'Jupe '+words[1]+' does not exist');
          end;
        end else begin
          send(sendtalk+'Jupe list');
          for a := 0 to maxjupe do if jupe[a].used then begin
            send(sendtalk+'   '+jupe[a].name+'   '+jupe[a].reason);
          end;
        end;
      end else if words2[0] = 'DISCONNECT' then begin
        if not user[num].sop then begin
          send(sendtalk+'DISCONNECT: You have no access to this command. Services Operator required.');
          exit;
        end;
        logwrite(logadmin,'DISCONNECT used by '+user[num].nick);
        diereason := 'DISCONNECT command used by '+user[num].nick;
        ButtondieClick(nil);
      end else if words2[0] = 'DIE' then begin
        if not user[num].sop then begin
          send(sendtalk+'DIE: You have no access to this command. Services Operator required.');
          exit;
        end;
        logwrite(logadmin,'DIE used by '+user[num].nick);
        diereason := 'DIE command used by '+user[num].nick;
        form1.formclose;
      end else if words2[0] = 'INIT' then begin
        if not user[num].sop then begin
          send(sendtalk+'INIT: You have no access to this command. Services Operator required.');
          exit;
        end;
        sendoperchannel(num,'INIT');
        diereason := 'Re initializing';
        ButtondieClick(nil);
        diereason := '';
        loaddb;
        loadconf;
        ButtonconnectClick(nil);
      end else if words2[0] = 'RESET' then begin
        if not user[num].o then begin
          send(sendtalk+'RESET: You have no access to this command. IRC Operator required.');
          exit;
        end;
        sendoperchannel(num,'RESET');
        if usesettime then mesend('SE :'+inttostr(irctime));
        sendreset;
      end else if words2[0] = 'RESETGLINE' then begin
        if not user[num].o then begin
          send(sendtalk+'RESETGLINE: You have no access to this command. IRC Operator required.');
          exit;
        end;
        sendoperchannel(num,'RESETGLINE');
        sendresetgline;
      end else if words2[0] = 'SAVEDB' then begin
        if not user[num].sop then begin
          send(sendtalk+'SAVEDB: You have no access to this command. Services Operator required.');
          exit;
        end;
        sendoperchannel(num,'SAVEDB');
        savedb;
        send(sendtalk+'Databases saved')
      end else begin
        send(sendtalk +'Unknown command: '+words[0]+'.')
      end;
    end;
    100:begin
      if scannerenabled then begin
        if words2[0] = 'SCANNER' then begin
          if (pos('*',words2[1]) > 0) or (pos('?',words2[1]) > 0) or (pos('@',words2[1]) > 0) then exit;
          if scannerenabled then begin
            s1 := '';
            for a := 0 to maxscanreason do if scanreason[a].p = words2[2] then s1 := scanreason[a].s;
            if s1 = '' then s1 := 'Insecure port detected: '+words2[2];
            addgline('*@'+words[1],irctime+scangduration,'-scanner-',s1);
            sendgline('*@'+words[1],scangduration,s1);
          end;
        end;
      end;
    end;
  end;
end;

procedure tform1.sendresetchan;
var
  a:integer;
  s:string;
begin
  if umode = 1 then begin
    for a := 0 to maxcs do if csavail[a] then begin
      chansend('J '+chanserv[a].name+' :'+inttostr(irctime));
      mesend('M '+chanserv[a].name+' +o '+p10id+chanid);
      if chanserv[a].topic <> '' then chansend('T '+chanserv[a].name+' :'+chanserv[a].topic);

      s := '';
      if chanserv[a].mlockyes <> '' then s := '+'+chanserv[a].mlockyes;
      if chanserv[a].mlockno <> '' then s := s + '-'+chanserv[a].mlockno;
      if s <> '' then chansend('M '+chanserv[a].name+' '+s);
    end;
  end;
end;


procedure tform1.sendresetgline;
var
  a,b:integer;
begin
  {synchronize G-list on all daemons}
  for a := 0 to maxglist do begin
    if glist[a].used then begin
      b := glist[a].date-irctime;
      if b > 0 then sendgline(glist[a].mask,b,glist[a].reason);
    end;
  end;
end;

procedure tform1.sendreset;
begin
  {sendreset isnt sent on netburst (P10)}
  sendresetchan;
end;

{code to execute once when connected to the net}
procedure tform1.spawnservices;
var
  a:integer;
  s1:string;
begin
  {labelstatus.caption := 'Status: Online';}
  {sync the clock of all daemons}
  {bring pseudo clients online}


  {for a := 0 to maxjupe do if jupe[a] <> '' then begin
    send(':'+servername+' SERVER '+jupe[a]+' 2 :Jupe');
  end;}
  if usesettime then mesend('SE :'+inttostr(irctime));
  for a := 0 to maxjupe do if jupe[a].used then begin
    mesend('S '+jupe[a].name+' 2 '+inttostr(boottime)+' '+inttostr(irctime)+' P10 '+jupe[a].numeric+'AAA 0 :JUPE '+jupe[a].reason);
  end;
  (*for a := 10 to 40009 do begin
    send(p10id+' N n'+inttostr(a)+' 1 700000000 '+servuserid+' '+servhost+' AAAAAA '+p10id+p10inttostr(a,3)+' :clone');
    {send(p10id+p10inttostr(a,3)+' J #zurna :'+inttostr(irctime));}
    if a and 63 = 0 then sendflush;
  end;*)

  mesend('N '+channick+' 1 1 '+servuserid+' '+servhost+' +kd AAAAAA '+p10id+chanid+' :'+changcos);
  mesend('N '+nicknick+' 1 1 '+servuserid+' '+servhost+' +kd AAAAAA '+p10id+nickid+' :'+nickgcos);
  mesend('N '+memonick+' 1 1 '+servuserid+' '+servhost+' +kd AAAAAA '+p10id+memoid+' :'+memogcos);
  mesend('N '+opernick+' 1 1 '+servuserid+' '+servhost+' +okd AAAAAA '+p10id+operid+' :'+opergcos);

  mesend('B '+operchannel+' '+inttostr(boottime)+' +ntsi '+p10id+operid+':o');

  {mode +nt-k AAAAA:o <-- -k key as parameter on server-server? assume: yes}
  {if umode, send all channels using B messages}
  for a := 0 to maxcs do if csavail[a] then begin
    {fored create channels and set modes from cs database}

    {if (chanserv[a].mlockyes <> '') or (chanserv[a].mlockno <> '') then begin
      s1 := ' +'+chanserv[a].mlockyes;
      if chanserv[a].mlockno <> '' then s1 := s1 + '-'+chanserv[a].mlockno;
    end else s1 := '';}

    if umode = 1 then send(p10id+' B '+chanserv[a].name+' '+inttostr(chanserv[a].ts)+' '+p10id+chanid+':o :%');
    if (chanserv[a].mlockyes <> '') or (chanserv[a].mlockno <> '') then begin
      s1 := '+'+chanserv[a].mlockyes;
      if chanserv[a].mlockno <> '' then s1 := s1 + '-'+chanserv[a].mlockno;
    end else s1 := '';
    if s1 <> '' then chansend('M '+chanserv[a].name+' '+s1);
    if chanserv[a].topic <> '' then chansend('T '+chanserv[a].name+' :'+chanserv[a].topic);
  end;
  send(p10id+' EB');
end;

procedure tform1.newuser(num:integer);
var
  a:integer;
  s1,s2,s3:string;
begin
  if autogreet <> '' then chansend(msgcommand+' '+user[num].idstr+' :'+autogreet);
  {check for being glined}
  s1 := ircupper(user[num].userid+'@'+user[num].host);
  s2 := ircupper(user[num].userid+'@'+user[num].ip);

  for a := 0 to maxglist do if glist[a].used then begin
    s3 := ircupper(glist[a].mask);
    if glist[a].date > irctime then begin
      if maskmatch(s3,s1) or maskmatch(s3,s2) then begin
        sendgline(glist[a].mask,glist[a].date-irctime,glist[a].reason);
      end;
    end;
  end;

  logwrite(logclient,'Client connect: '+user[num].nick+' ('+user[num].userid+'@'+user[num].host+')');
end;

procedure TForm1.Timer2Timer(Sender: TObject);
var
  a,b:integer;
  s,s2,sendtalk:string;
begin
  {expire glines}
  for a := 0 to maxglist do if glist[a].used then if glist[a].date < irctime+20 then begin
    logwrite(logremovegline,'G-line expired: '+glist[a].mask+' '+glist[a].reason);
    glist[a].used := false;
  end;
  {expire nicks}
  if nickexpire > 0 then for a := 0 to maxns do if nsavail[a] then begin
    if irctime > nickserv[a].lastdate + (nickexpire*86400) then begin
      b := getnick(nickserv[a].nick);
      if b >= 0 then begin
        user[b].nagstatus := -1;
        user[b].nsnum := -1;
        user[b].identified := false;
      end;

      nicksend('WA :Registered nick '+nickserv[a].nick+' expired');
      setns(a,'');
      nsavail[a] := false;
      nickserv[a].destroy;
      dec(reggednicks);
    end;
  end;

  {expire channels}
  if chanexpire > 0 then for a := 0 to maxcs do if csavail[a] then begin
    if irctime > chanserv[a].lastdate + (chanexpire*86400) then if not chanserv[a].founderjoined then begin
      chansend('WA :Registered channel '+chanserv[a].name+' expired');
      setcs(a,'');
      csavail[a] := false;
      chanserv[a].Destroy;
    end;
  end;

  if msgcommand = 'PRIVMSG' then s2 := 'P' else s2 := 'O';
  for a := 0 to maxuser do if useravail[a] then if not user[a].identified then if not user[a].o then if user[a].nsnum <> -1 then begin
    sendtalk := p10id+nickid+' '+s2+' '+user[a].idstr+' :';
    case user[a].nagstatus of
      1:begin
        if usekill then send(sendtalk+'You will be disconnected in 60 seconds if you do not comply.')
        else send(sendtalk+'Your nick will be changed in 60 seconds if you do not comply.');
        user[a].nagstatus := 2;
      end;
      2:begin
        send(sendtalk+'You now have 40 seconds to change your nick. The nick you are currently using is registered to another user.');
        user[a].nagstatus := 3;
      end;
      3:begin
        send(sendtalk+'You now have 20 seconds to change your nick. If you do not comply, I will change your nick for you. This is your final warning.');
        user[a].nagstatus := 4;
      end;
      4:begin
        if usekill then begin
          nicksend('D '+user[a].idstr+' :'+servername+'!'+nicknick+' (User did not identify)');
          removeuser(a);
        end else begin
          s := 'Guest'+inttostr(random(90000)+10000);
          send(sendtalk+'Your nick has been changed to '+s+'.');
          mesend('SN '+user[a].idstr+' '+s);
{         - dont change internal state, we will receive nickchange for this user soon
          setnick(a,s);
          user[a].nsnum := -1;
          user[a].identified := false;
          user[a].maskmatch := false;}
          user[a].nagstatus := -1;
        end;
      end;
    end
  end;
  sendflush;
end;

procedure tform1.startnag;
var
  sendcmd:string;
begin
  if (user[num].nagstatus = 0) and (not user[num].identified) then begin
    user[num].nagstatus := 1;
    user[num].maskmatch := nickaccess(num,user[num].nsnum,'') > 0;
    sendcmd := p10id+nickid+' '+msgcommand+' '+user[num].idstr+' :';
    send(sendcmd+'This nick is owned by someone else. Please choose another.');
    {if the mask doesnt match and secure no chance to identify}
    if user[num].maskmatch then send(sendcmd+'If this is your nick, type: /msg '+nicknick+' IDENTIFY <password>');
    {if guestnick then add entry to nag list}
  end;
end;

procedure tform1.nickchanged(num:integer);
var
  c:integer;
  s1:string;
begin
  c := getns(user[num].nick);
  if c >= 0 then if not nsavail[c] then c := -1;
  if user[num].identified then begin
    if user[num].nsnum < 0 then begin
      logwrite(loginvalid,'Invalid: internal error in nickchanged');
      mesend('SQ '+servername2+' 0 :Invalid: internal error in nickchanged');
      exit;
    end;
    nickserv[user[num].nsnum].num := -1;
    nickserv[user[num].nsnum].lastdate := irctime;
  end;
  user[num].nsnum := c;
  user[num].identified := false;
  user[num].maskmatch := false;
  user[num].nagstatus := 0;
  if c > -1 then begin
    if (user[num].ts <> 0) and (user[num].ts = nickserv[c].lastts) and (user[num].nick+'!'+user[num].userid+'@'+user[num].host = nickserv[c].lastmask) then begin
      if nickserv[c].privmsg then s1 := 'P ' else s1 := 'O ';
      nicksend(s1+user[num].idstr+' :You are recognised and identified');
      identify(num,c);
    end else begin
      startnag(num);
    end;
  end;
end;

procedure tform1.flushallchanmode;
var
  a:integer;
begin
  if chanmodeqcount = 0 then exit;
  for a := 0 to chanmodeqcount-1 do begin
    if channelavail[chanmodeq[a]] then if channel[chanmodeq[a]].needmode then flushchanmode(chanmodeq[a]);
  end;
  chanmodeqcount := 0;
end;

procedure tform1.flushchanmode(channum:integer);
var
  ch:tchannel;
  s:string;
begin
  if channelavail[channum] then if channel[channum].needmode then begin
    ch := channel[channum];
    if opermode or (umode = 2) then
    s := p10id+' M '+channel[channum].name+' '
    else s := p10id+chanid+' M '+channel[channum].name+' ';
    if ch.modeq[0] <> '' then s := s+'+'+ch.modeq[0];
    if ch.modeq[2] <> '' then s := s+'-'+ch.modeq[2];
    s := s + ch.modeq[1] + ch.modeq[3];
    send(s);
    forceflag := true;
    parsecommand(s);
    ch.modeq[0] := '';
    ch.modeq[1] := '';
    ch.modeq[2] := '';
    ch.modeq[3] := '';
    ch.needmode := false;
  end;
end;

procedure tform1.setchanmode(channum:integer;st:boolean;c:char;param:string);
const plusmin:array[0..1] of char='-+';
var
  a:integer;
  ch:tchannel;
begin
  if chanmodeqcount > 500 then flushallchanmode;
  if channum < 0 then exit;
  chanmodeq[chanmodeqcount] := channum;
  inc(chanmodeqcount);
  if st then a := 0 else a := 2;
  ch := channel[channum];
  ch.modeq[a] := ch.modeq[a]+c;
  ch.modeq[a+1] := ch.modeq[a+1]+' '+param;
  ch.needmode := true;
  if length(ch.modeq[0])+length(ch.modeq[2]) >= 6 then flushchanmode(channum);
end;

procedure tform1.parsemodelock(s:string;csnum:integer);
var
  a,b:integer;
begin
  if not csavail[csnum] then exit;
  chanserv[csnum].mlockno := '';
  chanserv[csnum].mlockyes := '';
  b := 0;
  for a := 1 to length(s) do begin
    if s[a] = '-' then b := 1
    else if s[a] = '+' then b := 2
    else begin
      if b = 1 then chanserv[csnum].mlockno :=chanserv[csnum].mlockno + s[a]
      else if b = 2 then chanserv[csnum].mlockyes :=chanserv[csnum].mlockyes + s[a]
    end;
  end;
end;

procedure tform1.parsemodechan(sendernum:integer;var params,params2:twords);
var
  a,b,c,d,e,f,g:integer;
  ch:tchannel;
  privs2:cprivsrec;
  goed:boolean;
  rescan:boolean;
  mlockyes,mlockno:string;
begin
  if sendernum >= 0 then if user[sendernum].k then forceflag := true; {allow (dont bounce) any modes set by another +k}
  b := getchanname(params2[1]);
  if b < 0 then exit;
  rescan := false;
  ch := channel[b];
  e := 3;
  if ch.csnum < 0 then begin
    mlockyes := '';
    mlockno := '';
  end else begin
    mlockyes := chanserv[ch.csnum].mlockyes;
    mlockno := chanserv[ch.csnum].mlockno;
  end;
  c := 0;
  for a := 1 to length(params[2]) do begin
    if params[2,a] = '-' then c := 1 else if params[2,a] = '+' then c := 2 else
    if params[2,a] = 'i' then begin
      if c = 2 then begin
        if (pos('i',mlockno) = 0) or forceflag then ch.i := true
        else setchanmode(b,false,'i','');
      end else if c = 1 then begin
        if (pos('i',mlockyes) = 0) or forceflag then ch.i := false
        else setchanmode(b,true,'i','');
      end;
    end else if params[2,a] = 'm' then begin
      if c = 2 then begin
        if (pos('m',mlockno) = 0) or forceflag then ch.m := true
        else setchanmode(b,false,'m','');
      end else if c = 1 then begin
        if (pos('m',mlockyes) = 0) or forceflag then ch.m := false
        else setchanmode(b,true,'m','');
      end;
    end else if params[2,a] = 't' then begin
      if c = 2 then begin
        if (pos('t',mlockno) = 0) or forceflag then ch.t := true
        else setchanmode(b,false,'t','');
      end else if c = 1 then begin
        if (pos('t',mlockyes) = 0) or forceflag then ch.t := false
        else setchanmode(b,true,'t','');
      end;
    end else if params[2,a] = 'n' then begin
      if c = 2 then begin
        if (pos('n',mlockno) = 0) or forceflag then ch.n := true
        else setchanmode(b,false,'n','');
      end else if c = 1 then begin
        if (pos('n',mlockyes) = 0) or forceflag then ch.n := false
        else setchanmode(b,true,'n','');
      end;
    end else if params[2,a] = 'p' then begin
      if c = 2 then begin
        if (pos('p',mlockno) = 0) or forceflag then ch.p := true
        else setchanmode(b,false,'p','');
      end else if c = 1 then begin
        if (pos('p',mlockyes) = 0) or forceflag then ch.p := false
        else setchanmode(b,true,'p','');
      end;
    end else if params[2,a] = 's' then begin
      if c = 2 then begin
        if (pos('s',mlockno) = 0) or forceflag then ch.s := true
        else setchanmode(b,false,'s','');
      end else if c = 1 then begin
        if (pos('s',mlockyes) = 0) or forceflag then ch.s := false
        else setchanmode(b,true,'s','');
      end;
    end else if params[2,a] = 'k' then begin
      if c = 2 then begin
        if (pos('k',mlockno) = 0) or forceflag then ch.k := params[e]
        else begin
          setchanmode(b,false,'k',params[e]);
        end;
      end else if c = 1 then begin
        if (pos('k',mlockyes) = 0) or forceflag then ch.k := ''
        else setchanmode(b,true,'k',params[e]);
      end;
      inc(e);
    end else if params[2,a] = 'l' then begin
      if c = 2 then begin
        if (pos('l',mlockno) = 0) or forceflag then ch.l := strtointdef(params[e],0)
        else setchanmode(b,false,'l','');
        inc(e);
      end else if c = 1 then begin
        if (pos('l',mlockyes) = 0) or forceflag then ch.l := 0
        else setchanmode(b,true,'l',inttostr(ch.l));
      end;
      {if c = 2 then ch.l := strtoint2(params[e],10) else ch.l := 0;
      if c = 2 then inc(e);}
    end else if params[2,a] = 'b' then begin
      if c = 2 then begin
        f := -1;
        g := -1;
        for d := maxban downto 0 do begin
          if ch.ban[d] = '' then f := d;
          if ircupper(ch.ban[d]) = params2[e] then g := d;
        end;
        if (g = -1) and (f <> -1) then ch.ban[f] := params[e];
      end else begin
        g := -1;
        for d := maxban downto 0 do begin
          if ircupper(ch.ban[d]) = params2[e] then g := d;
        end;
        if (g <> -1) then ch.ban[g] := '';
      end;
      inc(e);
    end else if params[2,a] = 'o' then begin
      d := getp10id(params[e]); {d is ge-opte user}
      if d = -1 then exit;     {b is channel}
      g := -1;
      for f := 0 to maxchanuser do if user[d].channel[f] = b then begin
        g := f;                {g is als user[d].channel[g]}
      end;
      if g = -1 then exit;
      goed := true;
      chanaccess(channel[b].csnum,d,privs2);
      if privs2.registered then begin
        if not privs2.aop then if (privs2.strictop) or ((sendernum < 0) and (umode <> 1)) or (sendernum = d) then goed := false;
      end;
      if (c = 1) or forceflag or user[d].k then goed := true;
      if goed then begin
        {accept mode change}
        if c = 2 then
        ch.userflag[user[d].channel2[g]] := ch.userflag[user[d].channel2[g]] or 2
        else
        ch.userflag[user[d].channel2[g]] := ch.userflag[user[d].channel2[g]] and not 2;
      end else begin
        {refuse/bounce mode change}
        setchanmode(b,false,'o',params[e]);
        rescan := true;
      end;
      inc(e);
    end else if params[2,a] = 'v' then begin
      d := getp10id(params[e]);
      if d = -1 then exit;
      g := -1;
      for f := 0 to maxchanuser do if user[d].channel[f] = b then begin
        g := f;
      end;
      if g = -1 then exit;
      if c = 2 then
      ch.userflag[user[d].channel2[g]] := ch.userflag[user[d].channel2[g]] or 1
      else
      ch.userflag[user[d].channel2[g]] := ch.userflag[user[d].channel2[g]] and not 1;
      inc(e);
    end else if params[2,a] = 'h' then inc(e);
  end;
  {scan entire channel again}
  c := ch.csnum;

  if rescan then begin
    if b >= 0 then begin
      for a := 0 to maxuserchan do if channel[b].user[a] >= 0 then begin
        chanaccess(c,channel[b].user[a],privs2);
        if not privs2.aop then begin
          if channel[b].userflag[a] and 2 <> 0 then setchanmode(b,false,'o',user[channel[b].user[a]].nick);
        end;
      end;
    end;
  end;
end;

{
operserv commands:

anyone access
HELP/COMMANDS shows list of commands the user has access to
TIME shows unix timestamp

ircop access
WHOIS - show extended+services info about user
BROADCAST - send message to $*

service operator access
GLINE (nick) or (mask), "3m" puts a gline. if nick, the mask is searched
RAW makes the services server send a raw string
MODE sets a channel mode
LOADCFG load conf
LOADNS
LOADCS

LOADDB load databases
SAVEDB force write of database
SUSPEND on|off close services for normal users, continue normally
DIE disconnect and terminate
}

{
chanserv commands

ACCESS shows a list of masks and nicks with level. anyone not on the list has level 0
LEVEL shows the level needed to access something

in config file are defauls for a new registered channel

usernum < 0 command is raw command
}
procedure tform1.parsemodeuser(usernum:integer;s:string);
var
  a,b,c:integer;
  us:tuser;
begin
  if usernum < 0 then exit;
  b := length(s);
  c := 0;
  us := user[usernum];
  for a := 1 to b do begin
    if s[a] = '-' then c := 1 else if s[a] = '+' then c := 2 else begin
      if s[a] = 'o' then begin
        if c = 2 then begin
          us.o := true;
          checksop(usernum)
        end else if c = 1 then begin
          us.o := false;
          us.sop := false
        end;
      end;
      if s[a] = 'd' then begin
        if c = 2 then us.d := true else if c = 1 then us.d := false;
      end;
      if s[a] = 'i' then begin
        if c = 2 then us.i := true else if c = 1 then us.i := false;
      end;
      if s[a] = 'r' then begin
        if c = 2 then us.r := true else if c = 1 then us.r := false;
      end;
      if s[a] = 'w' then begin
        if c = 2 then us.w := true else if c = 1 then us.w := false;
      end;
      if s[a] = 's' then begin
        if c = 2 then us.s := true else if c = 1 then us.s := false;
      end;
      if s[a] = 'x' then begin
        if c = 2 then us.s := true else if c = 1 then us.x := false;
      end;
      if s[a] = 'g' then begin
        if c = 2 then us.g := true else if c = 1 then us.g := false;
      end;
      if s[a] = 'k' then begin
        if c = 2 then us.k := true else if c = 1 then us.k := false;
      end;
    end;
  end;
end;

{
once per 20 seconds:
check users who are not identified and send 60 secs, 40 secs, 20 secs, kill
also expire G-lines internally
}

procedure tform1.logwrite(i:integer;s:string);
var
  a:integer;
begin
  if logging then if i and logmask <> 0 then begin
    a := (irctime-timezone) div 60;
    if (a div 1440) <> loglastdate then begin
      loglastdate := a div 1440;
      writeln(logfile,'*** '+timestrshort(irctime-timezone));
    end;


    s := '['+inttostr(a div 60 mod 24)+':'+inttostr(a mod 60)+'] '+s;
    writeln(logfile,s);
    flush(logfile);
  end;
end;

procedure tform1.addseen(num:integer);
begin
  currentseen := (currentseen+1) and maxseen;
  seenlist[currentseen].mask := user[num].nick+'!'+user[num].userid+'@'+user[num].host;
  seenlist[currentseen].date := irctime;
  seenlist[currentseen].fullname := user[num].gcos;
end;

procedure tform1.sendmotd(sender:string);
var
  t:textfile;
  goed:boolean;
  s:string;
begin
  goed := false;
  mesend('375 '+sender+' :- '+servername+' Message of the day');
  assignfile(t,'bircserv.motd');
  filemode := 0;
  {$i-}reset(t);{$i+}
  if ioresult = 0 then begin
    while not eof(t) do begin
      readln(t,s);
      goed := true;
      mesend('372 '+sender+' :- '+s);
    end;
    closefile(t);
  end;
  if not goed then mesend('372 '+sender+' :- No MOTD file');
  mesend('372 '+sender+' :-');
  mesend('372 '+sender+' :- Beware IRC Services, version '+versionstr);
  mesend('372 '+sender+' :- '+inttostr(reggednicks)+' registered nicks, '+inttostr(reggedchannels)+' registered channels');
  mesend('376 '+sender+' :End of /MOTD command');
end;

procedure tform1.destroyserver(b:integer);
var
  a:integer;
begin
  {recursively call for any servers behind this one}
  for a := 0 to maxserver do if server[a].parentserver = b then begin
    destroyserver(a);
  end;

  for a := 0 to maxuser do if useravail[a] then if user[a].servernum = b then begin
    removeuser(a);
  end;

  if server[b].p10id >= 0 then p10reverseserver[server[b].p10id] := -1;
  freemem(server[b].p10slots);
  server[b].used := false;
  server[b].name := '';
  server[b].uname := '';
  server[b].parentserver := -1;
end;

procedure TForm1.parsecommand(s:string);
const
  mparams=99;
var
  a,b,c,d,e,f,g,numparams:integer;
  s1,s2,s3:string;
  sender,cmd,sendcmd:string;
  sendernum,channum:integer;
  bool,goed:boolean;
  params,params2:twords;
  ls,ls2:array[0..1,0..19] of string;
  lsmax:array[0..1] of integer;
  lsburst:array[0..99] of string;
  privs:cprivsrec;
begin
{!!!  try}
  if (s = '') then exit;
  if length(s) > 510 then begin
    mesend('WA :received too long message, length '+inttostr(length(s))+' ['+copy(s,1,50)+']');
    exit;
  end;
  for g := 0 to mparams do params[g] := '';
  s2 := ansiuppercase(s);
  a := 1;
  if s[1] = ':' then begin
    a := pos(' ',s);
    sender := copy(s,2,a-2);
    sendernum := getnick(sender);
  end else begin
    if status = 2 then begin
      a := pos(' ',s);
      sender := convertidstr(copy(s,1,a-1));
      sendernum := getp10id(sender);
    end else begin
      sender := '';
      sendernum := -1
    end;
  end;
  while s[a] = ' ' do inc(a);
  b := 0;
  c := length(s);
  goed := false;
  while (a <= c) do begin
    if b > mparams then break;
    if s[a] = ':' then begin
      goed := true;
      break
    end;
    d := a;
    while (s[a] <> ' ') and (a <= c) do inc(a);
    params[b] := copy(s,d,a-d);
    inc(b);
    while (s[a] = ' ') and (a <= c) do inc(a)
  end;
  inc(a);
  if goed then begin
    params[b] := copy(s,a,c);
    inc(b)
  end;
{  if goed then inc(b);}
  numparams := b;
  for a := 0 to mparams do params2[a] := ircupper(Params[a]);
  cmd := params2[0];
  for a := 0 to 19 do for b := 0 to 1 do ls[b,a] := '';
  if (pos(',',params[1]) > 0) or (pos(',',params[2]) > 0) then begin
    for a := 0 to 1 do begin
      c := 0;
      d := length(params[a+1]);
      b := 1;
      while b <= d do begin
        if c >= mparams then break;
        e := b;
        while (params[a+1,b] <> ',') and (b <= d) do inc(b);
        ls[a,c] := copy(params[a+1],e,b-e);
        while (params[a+1,b] = ',') and (b <= d) do inc(b);
        inc(c);
      end;
      lsmax[a] := c
    end;
    for a := 0 to 1 do for b := 0 to lsmax[a] do ls2[a,b] := ircupper(ls[a,b]);
  end else begin
    ls[0,0] := params[1];
    ls[1,0] := params[2];
    ls2[0,0] := params2[1];
    ls2[1,0] := params2[1];
    lsmax[0] := 1;
    lsmax[1] := 1;
  end;
  if (cmd = 'ERROR') or (cmd = 'Y') then begin
    logwrite(logdisconnect,'received ERROR: '+params[numparams-1]);
    exit;
  end;


  if (status = 1) and (cmd = 'SERVER') then begin
    if params[7] = '' then halt;
    if params[5] <> 'J10' then halt; {ensure a correct link - is directly linked server}
    status := 2;
    servername2 := params[1];
    server[1].used := true;
    server[1].name := params[1];
    server[1].uname := params2[1];
    params[6] := convertidstr(params[6]);
    server[1].p10id := p10strtoint(copy(params[6],1,2));
    if server[1].p10id = p10idint then halt;
    p10reverseserver[server[1].p10id] := 1;
    server[1].p10max := p10strtoint(copy(params[6],3,3));
    getmem(server[1].p10slots,(server[1].p10max+1) shl 2);
    fillchar(server[1].p10slots^,(server[1].p10max+1) shl 2,-1);
    {create server object # 1 (directly linked server)}

    a := strtointdef(params[3],0);
    if a <> 0 then if a < boottime then boottime := a;

    spawnservices;
    exit
  end;
  {ping? pong!}
  sendcmd := msgcommand+' '+sender+' :';
  if cmd = 'G' then begin
    send(p10id+' Z '+servername+' :'+params[numparams-1]);
    exit
  end else if cmd = 'EB' then begin
    if sender = p10inttostr(server[1].p10id,2) then begin
      send(p10id+' EA');
    end;
  end else if (cmd = 'N') or (cmd = 'NICK') then begin
    a := getnick(params2[1]);
    if (a <> -1) and (a <> sendernum) then begin
      logwrite(loginvalid,'Invalid: nick collision: '+s);
      mesend('SQ '+servername2+' 0 :Invalid: nick collision: '+s);
      exit;
    end;
    if sendernum = -1 then begin
      b := adduser;
      setnick(b,params[1]);
      if params[8] <> '' then begin
        user[b].ts := strtointdef(params[3],0);

        user[b].userid := params[4];
        user[b].host := params[5];
        user[b].gcos := params[numparams-1];

        if params[6,1] = '+' then begin
          user[b].o := pos('o',params[6]) <> 0;
          user[b].i := pos('i',params[6]) <> 0;
          user[b].w := pos('w',params[6]) <> 0;
          user[b].s := pos('s',params[6]) <> 0;
          user[b].d := pos('d',params[6]) <> 0;
          user[b].k := pos('k',params[6]) <> 0;
          user[b].x := pos('x',params[6]) <> 0;
        end;
        params[numparams-2] := convertidstr(params[numparams-2]);
        user[b].servernum := p10reverseserver[p10strtoint(copy(params[numparams-2],1,2))];
        user[b].slotnum := p10strtoint(copy(params[numparams-2],3,3)) and server[user[b].servernum].p10max;
        server[user[b].servernum].p10slots[user[b].slotnum] := b;
        user[b].idstr := params[numparams-2];
        a := p10strtoint(params[numparams-3]);
        user[b].binip := a;
        user[b].ip := inttostr(a shr 24)+'.'+inttostr((a shr 16) and $ff)+'.'+inttostr((a shr 8) and $ff)+'.'+inttostr(a and $ff);
        newuser(b);
        nickchanged(b);
      end else begin
        logwrite(loginvalid,'Invalid: Received nick for not yet existing user with not enough params: '+s);
        mesend('SQ '+servername2+' 0 :Invalid: Received nick for not yet existing user with not enough params: '+s);
        exit;
      end;
    end else begin
      if ircupper(user[sendernum].nick) <> ircupper(params[1]) then begin
        setnick(sendernum,params[1]);
        user[sendernum].ts := strtointdef(params[2],0);
        nickchanged(sendernum)
      end else begin
        setnick(sendernum,params[1]);
        user[sendernum].ts := strtointdef(params[2],0);
      end;
    end;
  end else if cmd = 'S' then begin
    b := -1;
    for a := 0 to maxserver do if not server[a].used then begin
      b := a;
      break
    end;
    logwrite(logserver,'Server connection: '+params[1]);
    server[b].used := true;
    server[b].name := params[1];
    server[b].uname := params2[1];

    a := p10strtoint(sender);
    if a >= 0 then a := p10reverseserver[a];

    server[b].parentserver := a;

{    mesend('WA :test '+inttostr(b)+' '+sender+' '+inttostr(p10strtoint(sender)));}

    params[6] := convertidstr(params[6]);
    server[b].p10id := p10strtoint(copy(params[6],1,2));
    if server[b].p10id = p10idint then halt;
    p10reverseserver[server[b].p10id] := b;
    server[b].p10max := p10strtoint(copy(params[6],3,3));
    getmem(server[b].p10slots,(server[b].p10max+1) shl 2);
    fillchar(server[b].p10slots^,(server[b].p10max+1) shl 2,-1);

    a := strtointdef(params[3],0);
    if a <> 0 then if a < boottime then boottime := a;
  end else if cmd = 'P' then begin
    bool := pos('@',params2[1]) <> 0;
    params[1] := convertidstr(params[1]);
    if (params[1] = p10id+nickid) or (params2[1] = ircupper(nicknick)+'@'+ircupper(servername)) then bottalk(0,sendernum,params[numparams-1],bool) else
    if (params[1] = p10id+chanid) or (params2[1] = ircupper(channick)+'@'+ircupper(servername)) then bottalk(1,sendernum,params[numparams-1],bool) else
    if (params[1] = p10id+memoid) or (params2[1] = ircupper(memonick)+'@'+ircupper(servername)) then bottalk(2,sendernum,params[numparams-1],bool) else
    if (params[1] = p10id+operid) or (params2[1] = ircupper(opernick)+'@'+ircupper(servername)) then bottalk(3,sendernum,params[numparams-1],bool);
  end else if cmd = 'O' then begin
    if status = 2 then begin
      if sendernum = -1 then begin
        bottalk(100,0,params[numparams-1],false);
      end;
    end;
  end else if (cmd = 'J') or (cmd = 'C') then begin
    if sendernum < 0 then exit;
    if params[1] = '0' then begin
      for a :=  0 to maxchanuser do if user[sendernum].channel[a] >= 0 then begin
        parsecommand(sender+' L '+channel[user[sendernum].channel[a]].name);
      end;
      exit;
    end;
    for d := 0 to lsmax[0] do if ls2[0,d] <> '' then begin
      b := getchanname(ls2[0,d]);

      if b = -1 then begin
        b := addchannel;
        setchanname(b,ls[0,d]);
        channel[b].size := 0;
        c := getcs(channel[b].uname);
        channel[b].csnum := c;
        if c >= 0 then begin
          if umode = 1 then channel[b].ts := chanserv[c].ts;
          chanserv[c].num := b;
          {the user created a channel and its registered}
          if not (umode = 1) then begin
            if chanserv[c].welcome = '' then begin
              chansend('O '+sender+' :'+channel[b].name+' is a registered channel. Access privileges apply.');
            end;
            if (chanserv[c].mlockyes <> '') or (chanserv[c].mlockno <> '') then begin
              s1 := '+'+chanserv[c].mlockyes;
              if chanserv[c].mlockno <> '' then s1 := s1 + '-'+chanserv[c].mlockno;
            end else s1 := '';
            if s1 <> '' then chansend('M '+chanserv[c].name+' '+s1);
            if chanserv[c].topic <> '' then begin
              chansend('T '+channel[b].name+' :'+chanserv[c].topic);
            end;
          end;
        end;
        logwrite(logjoin,'Channel create: '+channel[b].name+' '+user[sendernum].nick);
      end;
      {add user to channel}
      for a :=  0 to maxchanuser do if user[sendernum].channel[a] = -1 then begin
        user[sendernum].channel[a] := b;
        for c := 0 to maxuserchan do if channel[b].user[c] = -1 then begin
          channel[b].user[c] := sendernum;
          channel[b].userflag[c] := 0;
          user[sendernum].channel2[a] := c;
          break;
        end;
        break;
      end;
      c := channel[b].csnum;
      chanaccess(c,sendernum,privs);
      if c >= 0 then begin
        if privs.level = -1 then begin
          setchanmode(b,true,'b','*!*@'+user[sendernum].host);
          flushchanmode(b);
          chansend('K '+channel[b].name+' '+user[sendernum].idstr+' :You are banned from this channel');
          removeuserchannel(b,sendernum);
        end else begin
          if user[sendernum].identified then if (user[sendernum].unick) = ircupper(chanserv[c].founder) then begin
            chanserv[c].lastdate := irctime;
            chanserv[c].founderjoined := true;
          end;
          if privs.aop then begin
            setchanmode(b,true,'o',sender)
          end  else if privs.avoice then setchanmode(b,true,'v',sender);
          if chanserv[c].welcome > '' then chansend('O '+sender+' :('+chanserv[c].name+') '+chanserv[c].welcome);
        end;
      end;
      inc(channel[b].size);
      if c >= 0 then if privs.level = 0 then if chanserv[c].operonly then if not user[sendernum].o then begin
        chansend('K '+channel[b].name+' '+user[sendernum].idstr+' :Only IRC Operators are allowed in this channel.');
        removeuserchannel(b,sendernum);
      end;
      if cmd = 'C' then if b >= 0 then begin
        channel[b].ts := strtointdef(params[2],0);
        parsecommand(p10inttostr(server[user[sendernum].servernum].p10id,2)+' M '+channel[b].name+' +o '+sender);
      end;
    end;
  end else if cmd = 'B' then begin
    {if received TS < known TS, change known TS in channel and chanserv
    if received TS > known TS, ignore ops&modes (netbreak rider)}
    {burst is done by parsing fake joins and modes}
    b := getchanname(params2[1]);
    if b = -1 then begin
      b := addchannel;
      setchanname(b,params[1]);
      channel[b].size := 0;
      channel[b].ts := strtointdef(params[2],0);
      c := getcs(channel[b].uname);
      channel[b].csnum := c;
      if c >= 0 then chanserv[c].num := b;
      if (umode = 1) and (channel[b].csnum >= 0) then begin
        if ((chanserv[c].ts > channel[b].ts) or (chanserv[c].ts = 0)) and (channel[b].ts <> 0) then begin
          {adjust chanserv's TS because receved TS is better}
          chanserv[c].ts := channel[b].ts;
        end;
        if (chanserv[c].ts <> 0) and (chanserv[c].ts < channel[b].ts) then begin
          {ignore mode changes because own TS is better}
          bool := true;
          channel[b].ts := chanserv[c].ts;
        end else bool := false;
      end else begin
        {chanserv isn't in channel}
        bool := false;
      end;
    end else begin
      bool := (channel[b].ts < strtointdef(params[2],0));
      if not bool then channel[b].ts := strtointdef(params[2],0);
    end;
    a := 3;
    while a < mparams do begin
      if params[a] <> '' then begin
        s1 := params[a];
        if s1[1] = '+' then begin
          {mode change}
          if bool then begin
            if pos('l',s3) <> 0 then inc(a);
            if pos('k',s3) <> 0 then inc(a);
          end else begin
            for d := 1 to length(s1) do begin
              if s1[d] = '+' then c := 2
              else if s1[d] = '-' then c := 1
              else if s1[d] = 'i' then channel[b].i := c = 2
              else if s1[d] = 'p' then channel[b].p := c = 2
              else if s1[d] = 's' then channel[b].s := c = 2
              else if s1[d] = 'n' then channel[b].n := c = 2
              else if s1[d] = 't' then channel[b].t := c = 2
              else if s1[d] = 'm' then channel[b].m := c = 2
              else if s1[d] = 'l' then begin
                if c = 2 then begin
                  inc(a);
                  channel[b].l := strtointdef(params[a],0);
                end else channel[b].l := 0
              end else if s1[d] = 'k' then begin
                inc(a);
                if c = 2 then channel[b].k := params[a] else channel[b].k := '';
              end
            end;
          end;
        end else if s1[1] = '%' then begin
          {bans and end of stream}
          a := 100;
          if not bool then begin
            for g := 0 to 99 do lsburst[g] := '';
            c := 0;
            d := length(s1);
            f := 2;
            while f <= d do begin
              if c >= 125 then break;
              e := f;
              while (s1[f] <> ' ') and (f <= d) do inc(f);
              lsburst[c] := copy(s1,e,f-e);
              while (s1[f] = ' ') and (f <= d) do inc(f);
              inc(c);
            end;
            lsmax[0] := c;
            s1 := '';
            s2 := '';
            for f := 0 to lsmax[0] do if lsburst[f] <> '' then begin
              s1 := s1 + 'b';
              s2 := s2 + ' '+lsburst[f];
              if length(s1) >= 6 then begin
                parsecommand(sender+' M '+channel[b].name+' +'+s1+s2);
                s1 := '';
                s2 := '';
              end;
            end;
            if s1 <> '' then parsecommand(sender+' M '+channel[b].name+' +'+s1+s2);
            {bans}
          end;
        end else begin
          {join users}
          for g := 0 to 99 do lsburst[g] := '';
          c := 0;
          d := length(params[a]);
          f := 1;
          while f <= d do begin
            if c >= 99 then break;
            e := f;
            while (params[a,f] <> ',') and (f <= d) do inc(f);
            lsburst[c] := copy(params[a],e,f-e);
            while (params[a,f] = ',') and (f <= d) do inc(f);
            inc(c);
          end;
          lsmax[0] := c;
          c := 0;
          for f := 0 to lsmax[0] do if lsburst[f] <> '' then begin
            d := pos(':',lsburst[f]);
            if d = 0 then s3 := lsburst[f] else begin
              s3 := copy(lsburst[f],1,d-1);
              lsburst[f] := copy(lsburst[f],d+1,10);
              c := 0;
              if (pos('o',lsburst[f]) > 0) then c := c or 2;
              if (pos('v',lsburst[f]) > 0) then c := c or 1;
            end;
            parsecommand(s3+' J '+params[1]);
            if not bool then begin
              if c and 2 = 2 then parsecommand(sender+' M '+params[1]+' +o '+s3);
              if c and 1 = 1 then parsecommand(sender+' M '+params[1]+' +v '+s3);
            end;
          end;
        end;
      end;
      inc(a);
    end;
  end else if cmd = 'L' then begin
    for d := 0 to lsmax[0] do if ls2[0,d] <> '' then begin
      b := getchanname(ls2[0,d]);
      if b <> -1 then removeuserchannel(b,sendernum)
    end;
  end else if cmd = 'T' then begin
    b := getchanname(params2[1]);
    if b >= 0 then begin
      channel[b].topic := params[numparams-1];
    end;
    a := getcs(params[1]);
    if a >= 0 then begin
      chanaccess(a,sendernum,privs);
      if privs.level > 1 then chanserv[a].topic := params[numparams-1];
    end;
  end else if cmd = 'K' then begin
    b := getchanname(params[1]);
    c := getnick(params[2]);
    if b <> -1 then if c <> -1 then begin
      removeuserchannel(b,c);
      logwrite(logkick,'Kick: '+channel[b].name+' '+user[c].nick);
    end;
  end else if (cmd = 'SVSNICK') then begin
    (*a := getp10id(params2[1]);
    if a < 0 then exit;
    setnick(a,params[2]);
    nickchanged(a)*)
  end else if cmd = 'Q' then begin
    if sendernum <> -1 then begin
      logwrite(logquit,'Client quit: '+user[sendernum].nick+' ('+user[sendernum].userid+'@'+user[sendernum].host+')');
      removeuser(sendernum)
    end;
  end else if cmd = 'SQ' then begin
    s2 := params2[1];
    b := -1;
    for a := 0 to maxjupe do if jupe[a].used then if maskmatch(s2,ircupper(jupe[a].name)) then begin
      jupe[a].used := false;
      exit;
    end;
    for a := 0 to maxserver do if server[a].used then if server[a].uname = s2 then begin
      b := a;
      break
    end;

    logwrite(logsquit,'Server quit: '+params[1]+' '+params[numparams-1]);
    destroyserver(b);

  end else if cmd = 'D' then begin
    a := getp10id(params[1]);
    if a <> -1 then begin
      logwrite(logrecvkill,'Kill: '+params[1]+' ('+params[numparams-1]+')');
      removeuser(a)
    end;
  end else if (cmd = 'M') or (cmd = 'OM') then begin
    if params[1] = '' then exit;
    if cmd = 'OM' then forceflag := true;
    if (params[1,1] = '#') then begin
      parsemodechan(sendernum,params,params2);
    end else begin
      parsemodeuser(getnick(params2[1]),params[2]);
    end;
  end else if cmd = 'CM' then begin
    b := getchanname(params2[1]);
    if b < 0 then exit;
    if params[2] = '' then params[2] := 'mntipslkovb';
    if pos('m',params[2]) <> 0 then channel[b].m := false;
    if pos('n',params[2]) <> 0 then channel[b].n := false;
    if pos('t',params[2]) <> 0 then channel[b].t := false;
    if pos('i',params[2]) <> 0 then channel[b].i := false;
    if pos('p',params[2]) <> 0 then channel[b].p := false;
    if pos('s',params[2]) <> 0 then channel[b].s := false;
    if pos('l',params[2]) <> 0 then channel[b].l := 0;
    if pos('k',params[2]) <> 0 then channel[b].k := '';
    if pos('o',params[2]) <> 0 then begin
      for a := 0 to maxuserchan do channel[b].userflag[a] := channel[b].userflag[a] and not 2;
    end;
    if pos('v',params[2]) <> 0 then begin
      for a := 0 to maxuserchan do channel[b].userflag[a] := channel[b].userflag[a] and not 1;
    end;
    if pos('b',params[2]) <> 0 then begin
      for a := 0 to maxban do channel[b].ban[a] := '';
    end;
  end else if cmd = 'V' then begin
    mesend('351 '+sender+' bserv'+versionstr+' '+servername+' :beware old IRC services');
  end else if cmd = 'MO' then begin
    sendmotd(sender);
  end else if cmd = 'WA' then begin
    logwrite(logrecvwallops,'Wallops: '+params[numparams-1]);
  end;
 {!!! except
    on e:exception do writeln('exception in parsecommand: '+e.message);
  end;}
end;

function convertidstr(const s:string):string;
begin
  case length(s) of
    2,5: result := s;
    3: result := 'A'+s[1]+'A'+s[2]+s[3];
    1,4: result := 'A'+s;
  end;
end;


function tform1.getp10id;
var
  a,b:integer;
begin
  s := convertidstr(s);
  result := -1;
  if length(s) = 5 then begin
    a := p10reverseserver[p10strtoint(copy(s,1,2))];
    if a <= 0 then exit;
    b := p10strtoint(copy(s,3,3));
    b := server[a].p10slots[b and server[a].p10max];
    if b < 0 then exit;
    if user[b].idstr = s then result := b
  end else if length(s) = 2 then begin
    a := p10reverseserver[p10strtoint(s)];
    if a > -1 then begin
      result := -1; {from server}
    end;
  end;
end;

function tform1.getnick(s:string):integer;
begin
  result := integer(findtree(@nickhash,ircupper(s))) - 1;
end;

function tform1.getns(s:string):integer;
begin
  result := integer(findtree(@nshash,ircupper(s))) - 1;
end;

function tform1.getchanname(s:string):integer;
begin
  result := integer(findtree(@channelhash,ircupper(s))) - 1;
end;

function tform1.getcs(s:string):integer;
begin
  result := integer(findtree(@cshash,ircupper(s))) - 1;
end;

procedure TForm1.receive(Sender: TObject; Error: Word);
var
  a,b,c,d:integer;
  s:string;
  goed:boolean;
begin
  with form1 do begin
  recvq := recvq + sock.receivestr;

  goed := false;
  a := 1;
  b := length(recvq);
  d := 0;
  repeat
    c := a;
    while (a <= b) and (recvq[a] <> #13) and (recvq[a] <> #10) do inc(a);
    if a <= b then begin
      s := copy(recvq,c,a-c);
      d := a;
      (*delete(us.recvq,1,a);*)
      if s <> '' then begin
        forceflag := false;
        logwrite(lograw,'RAW: '+s);
        parsecommand(s);
      end;
    end else goed := true;
    inc(a);
  until goed;
  if d > 0 then delete(recvq,1,d);
  forceflag := false;
  flushallchanmode;
  sendflush;
  end;
end;

procedure tform1.connected;
begin
  with form1 do begin

  if error = 0 then begin
    {labelstatus.caption := 'Status: Connected, logging in';}
    logwrite(logconnect,'Services connected to server');
    timerretry.enabled := false;
    status := 1;
    send('PASS :'+connectpass);
    send('SERVER '+servername+' 1 '+inttostr(boottime)+' '+inttostr(irctime)+' J10 '+p10id+'AA] :'+servergcos);
    sendflush
  end else begin
    logwrite(logconnect,'Services failed to connect to server, error '+inttostr(error));
  end;

  end;
end;

procedure tform1.closed;
begin
  with form1 do begin
  if wantstoconnect then begin
    {labelstatus.caption := 'Status: Disconnected, trying to reconnect';}
    timerretry.enabled := true;
  end{ else labelstatus.caption := 'Status: offline'};
  logwrite(logdisconnect,'Services disconnected from server, error '+inttostr(error));
  status := 0;
  clearserver;
  sock.close;
  end;
end;

{functions for nick and channelname allow the use of a hashtable to speed things up...}
procedure tform1.setnick(num:integer;s:string);
begin
  if user[num].unick <> '' then deltree(@nickhash,user[num].unick);
  user[num].nick := s;
  user[num].unick := ircupper(s);
  if user[num].unick <> '' then addtree(@nickhash,user[num].unick,pointer(num+1));
end;

procedure tform1.setns(num:integer;s:string);
begin
  if nickserv[num].unick <> '' then deltree(@nshash,nickserv[num].unick);
  nickserv[num].nick := s;
  nickserv[num].unick := ircupper(s);
  if nickserv[num].unick <> '' then addtree(@nshash,nickserv[num].unick,pointer(num+1));
end;

procedure tform1.setchanname(num:integer;s:string);
begin
  if channel[num].uname <> '' then deltree(@channelhash,channel[num].uname);
  channel[num].name := s;
  channel[num].uname := ircupper(s);
  if channel[num].uname <> '' then addtree(@channelhash,channel[num].uname,pointer(num+1));
end;

procedure tform1.setcs(num:integer;s:string);
begin
  if chanserv[num].uname <> '' then deltree(@cshash,chanserv[num].uname);
  chanserv[num].name := s;
  chanserv[num].uname := ircupper(s);
  if chanserv[num].uname <> '' then addtree(@cshash,chanserv[num].uname,pointer(num+1));
end;

procedure tform1.clearns;
var
  a:integer;
begin
  {clear nickserv database, the "neat" way. also all users are de-authed}
  for a := 0 to maxns do if nsavail[a] then begin
    setns(a,'');
    nickserv[a].destroy;
  end;
  reggednicks := 0;
  for a := 0 to maxuser do if useravail[a] then if user[a].nsnum > -1 then begin
    user[a].identified := false;
    user[a].maskmatch := false;
    user[a].nsnum := -1;
  end;
  fillchar(nsavail,sizeof(nsavail),0);
  maxns := 1;
end;

procedure tform1.clearcs;
var
  a:integer;
begin
  {clear chanserv database, the "neat" way. also part chanserv from any channels}
  for a := 0 to maxcs do if csavail[a] then begin
    if chanserv[a].num > -1 then begin
      chansend('PART :'+chanserv[a].name);
    end;
    setcs(a,'');
    chanserv[a].destroy;
  end;
  reggedchannels := 0;
  for a := 0 to maxchannel do if channelavail[a] then if channel[a].csnum <> -1 then channel[a].csnum := -1;
  fillchar(csavail,sizeof(csavail),0);
  maxcs := 1;
end;

procedure tform1.clearserver;
var
  a:integer;
begin
  {clear channels and users, the "neat" way}
  for a := 0 to maxuser2 do if useravail[a] then removeuser(a);
  fillchar(useravail,sizeof(useravail),0);
  maxuser := 1;
  for a := 0 to maxchannel2 do if channelavail[a] then removechannel(a);
  fillchar(channelavail,sizeof(channelavail),0);
  maxchannel := 1;
  for a := 1 to maxserver do if server[a].used then begin
    server[a].used := false;
    server[a].name := '';
    server[a].uname := '';
    if server[a].p10max > 0 then freemem(server[a].p10slots);
    if server[a].p10id >= 0 then p10reverseserver[server[a].p10id] := -1;
    server[a].p10max := 0;
  end;
end;

procedure tform1.removeuserchannel(channum,usernum:integer);
var
  a,c:integer;
begin
  for a := maxchanuser downto 0 do begin
    if user[usernum].channel[a] = channum then begin
      c := channel[channum].csnum;
      if c >= 0 then begin
        if user[usernum].identified then if (user[usernum].unick) = ircupper(chanserv[c].founder) then begin
          chanserv[c].lastdate := irctime;
          chanserv[c].founderjoined := false;
        end;
      end;
      channel[channum].user[user[usernum].channel2[a]] := -1;
      channel[channum].userflag[user[usernum].channel2[a]] := 0;
      user[usernum].channel[a] := -1;
      break
    end;
  end;
  dec(channel[channum].size);
  if channel[channum].size <= 0 then if ((umode <> 1) or (channel[channum].csnum < 0)) then begin
    removechannel(channum);
  end;
end;

procedure tform1.removeuser(num:integer);
var
  a:integer;
begin
  if not useravail[num] then exit;
  for a := 0 to maxchanuser do if user[num].channel[a] <> -1 then removeuserchannel(user[num].channel[a],num);
  if user[num].nsnum <> -1 then begin
    if user[num].identified then nickserv[user[num].nsnum].lastdate := irctime;
    nickserv[user[num].nsnum].num := -1
  end;
  server[user[num].servernum].p10slots[user[num].slotnum] := -1;
  if user[num].nick <> '' then addseen(num);
  useravail[num] := false;
  setnick(num,'');
  user[num].destroy;
end;

procedure tform1.removechannel(num:integer);
begin
  if not channelavail[num] then exit;
  if channel[num].csnum >= 0 then begin
    chanserv[channel[num].csnum].num := -1
  end;
  channelavail[num] := false;
  setchanname(num,'');
  channel[num].destroy;
end;

function tform1.adduser:integer;
var
  a,b:integer;
begin
  b := -1;
  result := -1;
  for a := 0 to maxuser+1 do if not useravail[a] then begin
    b := a;
    break;
  end;
  if b = -1 then begin
    if maxuser >= maxuser2-1 then exit;
    b := maxuser+1;
  end;
  if b > maxuser then maxuser := b;
  user[b] := tuser.create;

  user[b].id := random(maxlongint);
  for a := 0 to maxchanuser do user[b].channel[a] := -1;
  user[b].nsnum := -1;
  user[b].identified := false;

  useravail[b] := true;
  result := b
end;

function tform1.addchannel:integer;
var
  a,b:integer;
begin
  b := -1;
  result := -1;
  for a := 0 to maxchannel+1 do if not channelavail[a] then begin
    b := a;
    break;
  end;
  if b = -1 then begin
    if maxchannel >= maxchannel2-1 then exit;
    b := maxchannel+1;
  end;
  if b > maxchannel then maxchannel := b;
  channel[b] := tchannel.create;
  channel[b].csnum := -1;
  fillchar(channel[b].user,sizeof(channel[b].user),$ff);
  channelavail[b] := true;
  result := b;
end;


procedure TForm1.FormCreate(Sender: TObject);
var
  a:integer;
begin
  timer1 := tltimer.create(self);
  timer1.interval := 1000;
  timer1.ontimer := timer1timer;
  timer2 := tltimer.create(self);
  timer2.interval := 20000;
  timer2.ontimer := timer2timer;
  timerretry := tltimer.create(self);
  timerretry.interval := 4000;
  timerretry.ontimer := timerretrytimer;
  wantstoconnect := true;
  loglastdate := 0;
  randomize;
  btime.init;
  opermode := false;
  irctime := irctimeint;
  boottime := irctime;
  sock := twsocket.create(self);
  sock.onsessionconnected := connected;
  sock.ondataavailable := receive;
  sock.onsessionclosed := closed;
  new(user);
  maxuser:=1;
  fillchar(useravail,sizeof(useravail),0);
  fillchar(nickhash[0],sizeof(nickhash),0);
  new(nickserv);
  maxns:=1;
  fillchar(nsavail,sizeof(nsavail),0);
  fillchar(nshash[0],sizeof(nshash),0);
  new(channel);
  maxuser:=1;
  fillchar(channelavail,sizeof(channelavail),0);
  fillchar(channelhash[0],sizeof(channelhash),0);
  new(chanserv);
  maxcs:=1;
  fillchar(csavail,sizeof(csavail),0);
  fillchar(cshash[0],sizeof(cshash),0);
  fillchar(seenlist,sizeof(seenlist),0);
  for a := 0 to maxserver do server[a] := tserver.create;
  currentseen := 0;
  status := 0;
  init;
  chanmodeqcount := 0;

  server[0].used := true;
  server[0].p10max := 63;
  getmem(server[0].p10slots,(server[0].p10max+1) shl 2);

  timer2timer(nil); {expire things}
end;

{

nickserv record format

nick
regdate lastdate lastmask
password privmsg(0|1) private ircop
mail
url
access1 accessn
ignore1 ignoren
memo1 (sender time)
memo1 (message)
memon
memon

(empty line)


chanserv

channel
regdate lastdate
password priv strictop operop
url
sop
aop
}

procedure doewords(s:string;var words:twords);
var
  a,b:integer;
begin
  b := 0;
  for a := 0 to mparams do words[a] := '';
  a := 1;
  while (b < mparams) and (a <= length(s)) do begin
    if (s[a] <> ' ') and (s[a-1] = ' ') and (words[b] <> '') then inc(b);
    if (s[a] <> ' ') then words[b] := words[b] + s[a];
    inc(a)
  end;
end;


procedure tform1.loadnickserv;
const
  mparams=10;
var
  t:textfile;
  count,memocount:integer;
  s,s2,sv,sn:string;
  a:integer;
  words:twords;
begin
  clearns;
  assignfile(t,nickservfile);
  filemode := 0;
  {$i-}reset(t);{$i+}
  if ioresult <> 0 then exit;
  count := -1;
  memocount := -1;
  while not eof(t) do begin
    readln(t,s);
    if (pos('#',s) = 1) or (pos(';',s) = 1) then else begin
      s2 := ircupper(s);
      a := pos('=',s);
      if a <> 0 then begin
        sv := copy(s2,1,a-1);
        sn := copy(s,a+1,length(s))
      end else begin
        sv := '';
        sn := '';
      end;
      if sv = 'NICK' then begin
        inc(reggednicks);
        memocount := 0;
        inc(count);
        nickserv[count] := nil;
        nickserv[count] := tnickserv.create;

        nsavail[count] := true;
        nickserv[count].num := -1;
        setns(count,sn);
      end;
      if count >= 0 then begin
        if sv = 'GECOS' then nickserv[count].gcos := sn;
        if sv = 'REGDATE' then nickserv[count].regdate := strtointdef(sn,0);
        if sv = 'LASTDATE' then nickserv[count].lastdate := strtointdef(sn,0);
        if sv = 'TS' then nickserv[count].lastts := strtointdef(sn,0);
        if sv = 'LASTMASK' then nickserv[count].lastmask := sn;
        if sv = 'PASS' then nickserv[count].pass := sn;
        if sv = 'PRIVMSG' then nickserv[count].privmsg := sn = '1';
        if sv = 'PRIVATE' then nickserv[count].priv := sn = '1';
        if sv = 'EMAIL' then nickserv[count].email := sn;
        if sv = 'URL' then nickserv[count].url := sn;
        if sv = 'ACCESS' then begin
          doewords(sn,words);
          for a := 0 to maxnaccess do nickserv[count].mask[a] := words[a];
        end;
        if sv = 'IGNORE' then begin
          doewords(sn,words);
          for a := 0 to maxignore do nickserv[count].ignore[a] := words[a];
        end;
        if sv = 'MEMO' then begin
          doewords(sn,words);
          nickserv[count].memo[memocount].sender := words[0];
          nickserv[count].memo[memocount].date := strtointdef(words[1],0);
          nickserv[count].memo[memocount].s := copy(sn,pos(':',sn)+1,512);
          inc(memocount);
        end;
      end
    end;
  end;
  maxns := count;
  closefile(t);
end;

procedure tform1.savenickserv;
var
  t:textfile;
  s:string;
  a,b:integer;
begin
  assignfile(t,nickservfile);
  filemode := 2;
  rewrite(t);
  writeln(t,'# NICKSERV DATABASE');
  writeln(t,'');
  for a := 0 to maxns do if nsavail[a] then begin
    s := nickserv[a].nick;
    writeln(t,'nick=',s);
    writeln(t,'gecos=',nickserv[a].gcos);
    writeln(t,'regdate=',inttostr(nickserv[a].regdate));
    writeln(t,'lastdate=',inttostr(nickserv[a].lastdate));
    writeln(t,'TS=',inttostr(nickserv[a].lastts));
    writeln(t,'lastmask=',nickserv[a].lastmask);
    writeln(t,'pass=',nickserv[a].pass);
    if nickserv[a].privmsg then writeln(t,'privmsg=',inttostr(ord(nickserv[a].privmsg)));
    if nickserv[a].priv then writeln(t,'private=',inttostr(ord(nickserv[a].priv)));
    if nickserv[a].email <> '' then writeln(t,'email=',nickserv[a].email);
    if nickserv[a].url <> '' then writeln(t,'url=',nickserv[a].url);
    s := '';
    for b := 0 to maxnaccess do if nickserv[a].mask[b] <> '' then s := s + nickserv[a].mask[b]+' ';
    writeln(t,'access='+s);
    s := '';
    for b := 0 to maxignore do if nickserv[a].ignore[b] <> '' then s := s + nickserv[a].ignore[b]+' ';
    if s <> '' then writeln(t,'ignore='+s);

    for b := 0 to maxmemo do if nickserv[a].memo[b].sender <> '' then begin
      writeln(t,'memo='+nickserv[a].memo[b].sender+' '+inttostr(nickserv[a].memo[b].date)+' :'+nickserv[a].memo[b].s);
    end;
    writeln(t,''); {empty line}
  end;
  closefile(t);
end;

procedure tform1.loadchanserv;
const
  mparams=10;
var
  t:textfile;
  count:integer;
  s,s2,sv,sn:string;
  a:integer;
  words:twords;
begin
  clearcs;
  assignfile(t,chanservfile);
  filemode := 0;
  {$i-}reset(t);{$i+}
  if ioresult <> 0 then exit;
  count := -1;
  while not eof(t) do begin
    readln(t,s);
    s2 := ircupper(s);
    a := pos('=',s);
    if a <> 0 then begin
      sv := copy(s2,1,a-1);
      sn := copy(s,a+1,length(s))
    end;
    if (pos('#',s) = 1) or (pos(';',s) = 1) then else begin
      if sv = 'CHANNEL' then begin
        inc(reggedchannels);
        inc(count);
        chanserv[count] := tchanserv.create;
        csavail[count] := true;
        setcs(count,sn);
        chanserv[count].num := getchanname(chanserv[count].name);
        chanserv[count].mlockyes := 'tn';
      end;
      if sv = 'REGDATE' then chanserv[count].regdate := strtointdef(sn,0);
      if sv = 'LASTDATE' then chanserv[count].lastdate := strtointdef(sn,0);
      if sv = 'TS' then chanserv[count].ts := strtointdef(sn,0);
      if sv = 'OWNER' then chanserv[count].founder := sn;
      if sv = 'PASS' then chanserv[count].password := sn;
      if sv = 'PRIVATE' then chanserv[count].priv := sn = '1';
      if sv = 'STRICTOP' then chanserv[count].strictop := sn = '1';
      if sv = 'OPEROP' then chanserv[count].operop := sn = '1';
      if sv = 'OPERONLY' then chanserv[count].operonly := sn = '1';
      if sv = 'TOPIC' then chanserv[count].topic := sn;
      if sv = 'URL' then chanserv[count].url := sn;
      if sv = 'WELCOME' then chanserv[count].welcome := sn;
      if sv = 'MLOCK' then parsemodelock(sn,count);
      if sv = 'SOP' then begin
        doewords(sn,words);
        for a := 0 to maxsop do chanserv[count].aop[1,a] := words[a];
      end;
      if sv = 'AOP' then begin
        doewords(sn,words);
        for a := 0 to maxsop do chanserv[count].aop[0,a] := words[a];
      end;
      if sv = 'VOP' then begin
        doewords(sn,words);
        for a := 0 to maxsop do chanserv[count].aop[2,a] := words[a];
      end;
      if sv = 'AKICK' then begin
        doewords(sn,words);
        for a := 0 to maxsop do chanserv[count].aop[3,a] := words[a];
      end;
    end;
  end;
  maxcs := count;
  closefile(t);
end;

procedure tform1.savechanserv;
var
  t:textfile;
  s:string;
  a,b:integer;
begin
  assignfile(t,chanservfile);
  filemode := 2;
  rewrite(t);
  writeln(t,'# CHANSERV DATABASE');
  writeln(t,'');
  for a := 0 to maxcs do if csavail[a] then begin
    s := chanserv[a].name;
    writeln(t,'channel='+s);
    writeln(t,'regdate='+inttostr(chanserv[a].regdate));
    writeln(t,'lastdate='+inttostr(chanserv[a].lastdate));
    writeln(t,'TS='+inttostr(chanserv[a].ts));
    writeln(t,'owner='+chanserv[a].founder);
    writeln(t,'pass='+chanserv[a].password);
    s := '';
    if chanserv[a].mlockyes <> '' then s := '+'+chanserv[a].mlockyes;
    if chanserv[a].mlockno <> '' then s := s + '-'+chanserv[a].mlockno;

    writeln(t,'mlock='+s);
    if chanserv[a].priv then writeln(t,'private='+inttostr(ord(chanserv[a].priv)));
    if chanserv[a].strictop then writeln(t,'strictop='+inttostr(ord(chanserv[a].strictop)));
    if chanserv[a].operop then writeln(t,'operop='+inttostr(ord(chanserv[a].operop)));
    if chanserv[a].operonly then writeln(t,'operonly='+inttostr(ord(chanserv[a].operonly)));
    if chanserv[a].topic <> '' then writeln(t,'topic='+chanserv[a].topic);
    if chanserv[a].url <> '' then writeln(t,'url='+chanserv[a].url);
    if chanserv[a].welcome <> '' then writeln(t,'welcome='+chanserv[a].welcome);
    s := '';
    for b := 0 to maxsop do if chanserv[a].aop[1,b] <> '' then s := s + chanserv[a].aop[1,b]+' ';
    writeln(t,'sop=',s);
    s := '';
    for b := 0 to maxsop do if chanserv[a].aop[0,b] <> '' then s := s + chanserv[a].aop[0,b]+' ';
    writeln(t,'aop=',s);
    s := '';
    for b := 0 to maxsop do if chanserv[a].aop[2,b] <> '' then s := s + chanserv[a].aop[2,b]+' ';
    writeln(t,'vop=',s);
    s := '';
    for b := 0 to maxsop do if chanserv[a].aop[3,b] <> '' then s := s + chanserv[a].aop[3,b]+' ';
    writeln(t,'akick=',s);
    writeln(t,'');
  end;
  closefile(t);
end;


procedure TForm1.ButtondieClick(Sender: TObject);
begin
  wantstoconnect := false;
  if status <> 0 then begin
    if diereason = '' then diereason := 'Shutting down';
    chansend('Q :brb');
    mesend('SQ '+servername2+' 0 :'+diereason);
    sendflush;
    status := 0;
    sock.flush;
    sock.close;
    clearserver;
  end;
end;

procedure TForm1.ButtonconnectClick(Sender: TObject);
begin
  wantstoconnect := true;
  if status <> 0 then exit;
  sock.addr := connectaddr;
  sock.port := connectport;
  sock.proto := 'tcp';
  recvq := '';
  sendq := '';
  sock.connect;
end;

procedure tform1.loadconf;
var
  t:textfile;
  s,s2,sv,sn:string;
  words:twords;
  a,b,c:integer;
begin
  fillchar(p10reverseserver,sizeof(p10reverseserver),-1);
  if logging then begin
    logging := false;
    closefile(logfile);
  end;
  {get defaults}
  fillchar(sop,sizeof(sop),0);
  nicknick := 'NickServ';
  channick := 'ChanServ';
  memonick := 'MemoServ';
  opernick := 'OperServ';
  nickgcos := '/msg NickServ help';
  changcos := '/msg ChanServ help';
  memogcos := '/msg MemoServ help';
  opergcos := 'IRC Operator service';
  servername := 'services.server';
  servergcos := 'beware ircd services';
  p10idint := random(4096);
  servhost := 'services.server';
  servuserid := 'service';
  connectaddr := '127.0.0.1';
  connectport := '6667';
  connectpass := 'pass';
  operchannel := '#OperServ';
  fillchar(scanreason,sizeof(scanreason),0);
  umode := 1;
  usekill := false;
  usesettime := false;
  nickexpire := 30;
  chanexpire := 30;
  clonewarn := 0;
  clonekill := 0;
  logname := '';
  logmask := 0;
  autogreet := '';
  msgcommand := 'O';
  maxchanregs := 2;
  allownickreg := true;
  allowchanreg := true;
  safeidentify := true;
  hiddenhost := true;
  cryptpass := true;
  filemode := 0;
  assignfile(t,configfile2);
  {$i-}reset(t);{$i+}
  if ioresult <> 0 then begin
    assignfile(t,configfile);
    {$i-}reset(t);{$i+}
    if ioresult <> 0 then exit;
  end;
  while not eof(t) do begin
    readln(t,s);
    if (pos('#',s) = 1) or (pos(';',s) = 1) then else begin
      s2 := ircupper(s);
      a := pos('=',s);
      if a <> 0 then begin
        sv := copy(s2,1,a-1);
        sn := copy(s,a+1,length(s))
      end;
      if sv='SOP' then begin
        doewords(sn,words);
        for a := 0 to mparams do if (a <= maxsop) and (a <= mparams) then sop[a] := words[a];
      end;
      if sv='CONNECTADDR' then connectaddr := sn;
      if sv='CONNECTPORT' then connectport := sn;
      if sv='CONNECTPASS' then connectpass := sn;

      if sv='SERVERNAME' then servername := sn;
      if sv='SERVERGCOS' then servergcos := sn;
      if sv='SERVERID' then p10idint := strtointdef(sn,p10idint) and 4095;
      if sv='SERVHOST' then servhost := sn;
      if sv='SERVUSERID' then servuserid := sn;
      if sv='NICKNICK' then nicknick := sn;
      if sv='NICKGCOS' then nickgcos := sn;
      if sv='CHANNICK' then channick := sn;
      if sv='CHANGCOS' then changcos := sn;
      if sv='MEMONICK' then memonick := sn;
      if sv='MEMOGCOS' then memogcos := sn;
      if sv='OPERNICK' then opernick := sn;
      if sv='OPERGCOS' then opergcos := sn;
      if sv='USEKILL' then usekill := sn = '1';
      if sv='SETTIME' then usesettime := sn = '1';
      if sv='UMODE' then umode := strtointdef(sn,umode);
      if sv='SCANNER' then scannerenabled := sn = '1';
      if sv='SCANGDURATION' then scangduration := strtoint2(sn,9);
      if sv='NICKEXPIRE' then nickexpire := strtointdef(sn,nickexpire);
      if sv='CHANEXPIRE' then chanexpire := strtointdef(sn,chanexpire);
      if sv='MAXCHANPERUSER' then maxchanregs := strtointdef(sn,maxchanregs);
      if sv='CLONEWARN' then clonewarn := strtointdef(sn,clonewarn);
      if sv='CLONEKILL' then clonekill := strtointdef(sn,clonekill);
      if sv='LOGFILE' then logname := sn;
      if sv='LOGMASK' then logmask := strtointdef(sn,logmask);
      if sv='AUTOGREET' then autogreet := sn;
      if sv='HIDDENHOST' then hiddenhost := sn = '1';
      if sv='CRYPTPASS' then cryptpass := sn = '1';
      if sv='MSGCOMMAND' then begin
        if sn = 'PRIVMSG' then sn := 'P' else msgcommand := 'O'
      end;
      if sv='ALLOWNICKREG' then allownickreg := sn = '1';
      if sv='ALLOWCHANREG' then allowchanreg := sn = '1';
      if sv='SAFEIDENTIFY' then safeidentify := sn = '1';
      if sv='OPERCHANNEL' then operchannel := sn;
      if pos('SCANREASON',sv) = 1 then begin
        b := -1;
        c := -1;
        s2 := ircupper(copy(sv,11,200));
        for a := maxscanreason downto 0 do begin
          if scanreason[a].p = s2 then b := a;
          if scanreason[a].p = '' then c := a;
        end;
        if b >= 0 then begin
          scanreason[b].p := s2;
          scanreason[b].s := sn;
        end else if c >= 0 then begin
          scanreason[c].p := s2;
          scanreason[c].s := sn;
        end;
      end;
    end;
  end;
  msgcommand := ircupper(msgcommand);
  if msgcommand <> privmsgconst then msgcommand := noticeconst;

  closefile(t);
  logging := false;
  if logname <> '' then begin
    filemode := 2;
    assignfile(logfile,logname);
    {$i-}append(logfile);{$i+}
    if ioresult <> 0 then begin
      {$i-}rewrite(logfile);{$i+}
      logging := ioresult = 0;
    end else logging := true;
  end;
  {}
  p10id := p10inttostr(p10idint,2);
  server[0].p10id := p10idint;
  p10reverseserver[server[0].p10id] := 0;
  server[0].name := servername;
  server[0].uname := ircupper(servername);
end;

procedure tform1.init;
begin
  loadconf;
  loaddb;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  a,b,c:integer;
  s:string;
begin
  btime.timehandler;

  {scanhandler;}
  inc(irctime);
  if status = 0 then exit;
  if irctime mod 180 = 0 then begin
    savedb;
    if irctime mod 1800 = 0 then if usesettime then mesend('SE '+inttostr(irctime));
  end;
  if irctime and 3 = 0 then begin
    if (clonekill > 0) or (clonewarn > 0) then begin
      for a := 0 to maxuser do if useravail[a] then if not user[a].clonechecked then begin
        s := user[a].host;
        c := 0;
        for b := 0 to maxuser do if useravail[b] then begin
          if user[b].host = s then begin
            inc(c);
            user[b].clonechecked := true;
          end;
        end;
        if clonewarn > 0 then if c >= clonewarn then begin
          opersend('WA :Clone warning: '+inttostr(c)+' clones from '+user[a].nick+'!'+user[a].userid+'@'+user[a].host);
        end;
        if clonekill > 0 then if c >= clonekill then begin
          for b := maxuser downto 0 do if useravail[b] then if user[b].host = s then if not user[b].o then begin
            if c >= clonekill then begin
              opersend('D '+user[b].idstr+' :'+servername+'!'+opernick+' (Too many connections from your host)');
              removeuser(b);
            end;
            dec(c);
          end;
        end
      end;
    end
  end;
  if status <> 0 then sendflush else sendq := '';
end;

procedure TForm1.FormClose;
begin
  exitmessageloop;
end;

procedure TForm1.TimerretryTimer(Sender: TObject);
begin
  if status = 0 then if wantstoconnect then begin
    buttonconnectclick(nil);
  end;
end;

end.
